VirtualBox

source: vbox/trunk/configure@ 78022

Last change on this file since 78022 was 78022, checked in by vboxsync, 5 years ago

configure: Attempt to make detection and configuration of PulseAudio more consistent.

  • Property svn:eol-style set to LF
  • Property svn:executable set to *
File size: 78.0 KB
Line 
1#!/bin/sh
2# The purpose of this script is to check for all external tools, headers, and
3# libraries VBox OSE depends on.
4
5#
6# Copyright (C) 2006-2019 Oracle Corporation
7#
8# This file is part of VirtualBox Open Source Edition (OSE), as
9# available from http://www.virtualbox.org. This file is free software;
10# you can redistribute it and/or modify it under the terms of the GNU
11# General Public License (GPL) as published by the Free Software
12# Foundation, in version 2 as it comes in the "COPYING" file of the
13# VirtualBox OSE distribution. VirtualBox OSE is distributed in the
14# hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
15#
16
17LC_ALL=C
18export LC_ALL
19
20# append some extra paths
21PATH="$PATH:/opt/gnome/bin"
22# Solaris (order of paths important for tr, grep, sed to work)
23PATH="/usr/xpg4/bin:$PATH:/usr/local/bin:/usr/sfw/bin:/usr/ccs/bin"
24ORGPATH=$PATH
25
26# Wrapper for ancient /usr/bin/which on darwin that always returns 0
27which_wrapper()
28{
29 if [ -z "$have_ancient_which" ]; then
30 if which /bin/___cErTaINly_a_nOn_eXisTing_fIle___ 2> /dev/null > /dev/null; then
31 have_ancient_which="yes"
32 else
33 have_ancient_which="no"
34 fi
35 fi
36 if [ "$have_ancient_which" = "yes" ]; then
37 retval=`which $* 2>/dev/null`
38 echo "$retval"
39 test -n "$retval" -a -x "$retval"
40 unset retval
41 else
42 which $* 2> /dev/null
43 fi
44}
45
46OS=`uname -s | sed -e 's/GNU\/Linux/Linux/g' | tr '[:upper:]' '[:lower:]'`
47case "$OS" in
48 linux)
49 ;;
50 darwin)
51 ;;
52 freebsd)
53 ;;
54 netbsd)
55 ;;
56 sunos)
57 OS='solaris'
58 ;;
59 haiku)
60 ;;
61 *)
62 echo "Cannot determine OS!"
63 exit 1
64 ;;
65esac
66
67#
68# Defaults
69#
70OSE=1
71ODIR="`pwd`/"
72ODIR_OVERRIDE=0
73OUT_PATH=""
74OUT_PATH_OVERRIDE=0
75SETUP_WINE=
76ONLY_ADDITIONS=0
77TARGET_MACHINE=""
78TARGET_CPU=""
79WITH_XPCOM=1
80WITH_PYTHON=1
81WITH_JAVA=1
82WITH_VMMRAW=1
83WITH_LIBIDL=1
84WITH_GSOAP=0
85WITH_QT5=1
86WITH_SDL=1
87WITH_SDL_TTF=1
88WITH_X11=1
89WITH_ALSA=1
90WITH_PULSE=1
91WITH_DBUS=1
92WITH_DEVMAPPER=1
93WITH_KMODS=1
94WITH_OPENGL=1
95WITH_HARDENING=1
96WITH_UDPTUNNEL=1
97WITH_VDE=0
98WITH_VNC=0
99WITH_EXTPACK=1
100WITH_DOCS=1
101WITH_LIBVPX=1
102WITH_LIBOPUS=1
103BUILD_LIBXML2=
104BUILD_LIBCURL=
105BUILD_LIBSSL=
106BUILD_LIBVPX=
107PASSIVE_MESA=0
108CC="gcc"
109CC32=""
110CC64=""
111CXX="g++"
112CXX32=""
113CXX64=""
114YASM="yasm"
115IASL="iasl"
116XSLTPROC="xsltproc"
117GENISOIMAGE="genisoimage"
118INCCRYPTO=""
119LIBCRYPTO="-lssl -lcrypto"
120LIBPTHREAD="-lpthread"
121LIBCAP="-lcap"
122GSOAP=""
123GSOAP_IMPORT=""
124INCX11="/usr/local/include"
125LIBX11="-L/usr/X11R6/lib -L/usr/X11R6/lib64 -L/usr/local/lib -lXext -lX11"
126LIBXCURSOR="-lXcursor"
127LIBXMU="-lXmu"
128LIBXINERAMA="-lXinerama"
129LIBXRANDR="-lXrandr"
130MAKESELF="makeself"
131MESA="-lGL"
132INCZ=""
133LIBZ="-lz"
134INCVNCSERVER=""
135LIBVNCSERVER="-lvncserver"
136INCDEVMAPPER=""
137LIBDEVMAPPER="-ldevmapper"
138CXX_FLAGS=""
139if [ "$OS" = "freebsd" ]; then
140 INCCURL="-I/usr/local/include"
141 LIBCURL="-L/usr/local/lib -lcurl"
142 INCPULSE="-I/usr/local/include"
143 LIBPULSE="-L/usr/local/lib"
144 INCPNG="-I/usr/local/include"
145 LIBPNG="-L/usr/local/lib -lpng"
146else
147 INCCURL=""
148 LIBCURL="-lcurl"
149 INCPNG=""
150 LIBPNG="-lpng"
151fi
152INCVPX=""
153LIBVPX="-lvpx"
154PKGCONFIG="`which_wrapper pkg-config`"
155PYTHONDIR="/usr /usr/local"
156QT5DIR="/usr/lib/qt5 /usr/share/qt5 /usr/lib64/qt5 /usr /usr/local"
157QT5DIR_PKGCONFIG=1
158QT5MAJ=5
159QT5MIN=6
160KBUILDDIR="`cd \`dirname $0\`; pwd`/kBuild"
161DEVDIR="`cd \`dirname $0\`; pwd`/tools"
162if [ -d "/lib/modules/`uname -r`/build" ]; then
163 LINUX="/lib/modules/`uname -r`/build"
164elif [ "`echo /lib/modules/*`" != "/lib/modules/*" ]; then
165 # Get the most recent kernel headers if none match the current kernel.
166 for i in /lib/modules/*; do
167 if [ -r "$i/build" ]; then
168 LINUX="$i/build"
169 fi
170 done
171fi
172if [ -z "$LINUX" ]; then
173 LINUX="/usr/src/linux"
174fi
175KCHMVIEWER="kchmviewer"
176LOG="configure.log"
177CNF="AutoConfig.kmk"
178ENV="env.sh"
179BUILD_TYPE="release"
180# the restricting tool is ar (mri mode).
181INVALID_CHARS="[^A-Za-z0-9/\\$:._-]"
182
183if (cd `dirname $0`; pwd)|grep -q "$INVALID_CHARS"; then
184 echo "Error: VBox base path contains invalid characters!"
185 exit 1
186fi
187
188# Posix /bin/sh isn't supporting echo -n. Use printf instead.
189ECHO_N="printf"
190
191
192cleanup()
193{
194 rm -f $ODIR.tmp_src.cc $ODIR.tmp_src.c $ODIR.tmp_out $ODIR.test_execute.log
195}
196
197fail()
198{
199 if [ -z "$nofatal" -o "x$1" != "x" ]; then
200 cleanup
201 rm -f $ENV
202 echo "Check $LOG for details"
203 exit 1
204 fi
205}
206
207log()
208{
209 echo "$1"
210 echo "$1" >> $LOG
211}
212
213log_success()
214{
215 if [ -n "$1" ]; then $ECHO_N "$1, "; fi
216 echo "OK."
217 echo "$1" >> $LOG
218 echo >> $LOG
219 echo >> $LOG
220}
221
222log_failure()
223{
224 echo
225 echo " ** $1!"
226 echo "** $1!" >> $LOG
227 echo >> $LOG
228}
229
230cnf_append()
231{
232 printf "%-30s := %s\n" "$1" "$2" >> $CNF
233}
234
235strip_l()
236{
237 echo "$1"|$KBUILD_SED 's|-l\([^ ]\+\)|\1|g; s|^-[^l][^ ]*||g; s| -[^l][^ ]*||g; s|^ ||; s| *$||g'
238}
239
240strip_L()
241{
242 echo "$1"|$KBUILD_SED 's|-L\([^ ]\+\)|\1|g; s|^-[^L][^ ]*||g; s| -[^L][^ ]*||g; s|^ ||; s| *$||g'
243}
244
245strip_I()
246{
247 echo "$1"|$KBUILD_SED 's|-I\([^ ]\+\)|\1|g; s|^-[^I][^ ]*||g; s| -[^I][^ ]*||g; s|^ ||; s| *$||g'
248}
249
250prefix_I()
251{
252 echo "$1"|$KBUILD_SED 's|^\/|-I/|g; s| \/| -I/|g'
253}
254
255check_avail()
256{
257 if [ -z "$1" ]; then
258 log_failure "$2 is empty"
259 fail $3
260 return 1
261 elif which_wrapper $1 > /dev/null; then
262 return 0
263 else
264 log_failure "$1 (variable $2) not found"
265 fail $3
266 return 1
267 fi
268}
269
270
271# Prepare a test
272test_header()
273{
274 echo "***** Checking $1 *****" >> $LOG
275 $ECHO_N "Checking for $1: "
276}
277
278
279# Compile a test
280# $1 compile flags/libs
281# $2 library name
282# $3 package name
283# $4 if this argument is 'nofatal', don't abort
284test_compile()
285{
286 echo "compiling the following source file:" >> $LOG
287 cat $ODIR.tmp_src.cc >> $LOG
288 echo "using the following command line:" >> $LOG
289 echo "$CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc \"$1\"" >> $LOG
290 $CXX $CXX_FLAGS -fPIC -g -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc $1 >> $LOG 2>&1
291 if [ $? -ne 0 ]; then
292 if [ -z "$4" ]; then
293 echo
294 echo " $2 not found at $1 or $3 headers not found"
295 echo " Check the file $LOG for detailed error information."
296 fail
297 else
298 echo >> $LOG
299 echo >> $LOG
300 fi
301 return 1
302 fi
303 return 0
304}
305
306
307# Execute a compiled test binary
308test_execute()
309{
310 echo "executing the binary" >> $LOG
311 $ODIR.tmp_out > $ODIR.test_execute.log
312 rc=$?
313 cat $ODIR.test_execute.log | tee -a $LOG
314 if [ $rc -ne 0 ]; then
315 fail $1
316 return 1
317 fi
318 echo >> $LOG
319 echo >> $LOG
320 return 0
321}
322
323
324# Execute a compiled test binary
325test_execute_path()
326{
327 ## LD_LIBRARY_PATH to set.
328 local_path="${1}"
329 ## Set this to non-empty to make this test non-fatal.
330 local_nofail="${2}"
331 echo "executing the binary (LD_LIBRARY_PATH=$1)" >> $LOG
332 LD_LIBRARY_PATH="${local_path}" $ODIR.tmp_out > $ODIR.test_execute.log
333 rc=$?
334 cat $ODIR.test_execute.log | tee -a $LOG
335 if [ $rc -ne 0 ]; then
336 test -z "${local_nofail}" && fail
337 echo >> $LOG
338 echo >> $LOG
339 return 1
340 fi
341 echo >> $LOG
342 echo >> $LOG
343 return 0
344}
345
346
347#
348# Check for OS, MACHINE, CPU
349#
350check_environment()
351{
352 test_header environment
353 BUILD_CPU=`uname -m`
354 [ "$OS" = "solaris" ] && BUILD_CPU=`isainfo | cut -f 1 -d ' '`
355 case "$BUILD_CPU" in
356 i[3456789]86|x86|i86pc|BePC)
357 BUILD_MACHINE='x86'
358 LIB='lib'
359 ;;
360 x86_64|amd64)
361 BUILD_MACHINE='amd64'
362 BUILD_CPU='k8'
363 if [ "$OS" != "solaris" ]; then
364 # on AMD64 systems, 64bit libs are usually located in /usr/lib64
365 # see http://www.pathname.com/fhs/pub/fhs-2.3.html#LIB64
366 LIB='lib64'
367 else
368 # Solaris doesn't seem to subscribe to fhs, libs are usually in
369 # a '64' subdirectory of the standard 'lib' dirs while some 64-bit
370 # alternative binaries can be found in 'amd64' subdirs of the 'bin'
371 # ones. So, in order to find the right stuff (esp. sdl-config) we'll
372 # have to make sure the */bin/amd64 dirs are searched before the */bin
373 # ones. (The sed has some sideeffects, but they shouldn't harm us...)
374 echo "64-bit Solaris detected, hacking the PATH" >> $LOG
375 echo "old PATH: $PATH" >> $LOG
376 PATH=`echo ":$PATH:" | sed -e 's,\(:[^:]*/bin\):,\1/amd64:\1:,g' \
377 -e 's/^:*//' -e 's/:*$//g' -e 's/::*/:/g' `
378 export PATH
379 echo "new PATH: $PATH" >> $LOG
380 LIB='lib/64'
381 fi
382 ;;
383 sparc64|sparcv9)
384 BUILD_MACHINE='sparc64'
385 BUILD_CPU='blend'
386 ;;
387 sparc32|sparc|sparcv8|sparcv7|sparcv8e)
388 BUILD_MACHINE='sparc32'
389 BUILD_CPU='blend'
390 ;;
391 *)
392 log_failure "Cannot determine system"
393 exit 1
394 ;;
395 esac
396 [ -z "$TARGET_MACHINE" ] && TARGET_MACHINE=$BUILD_MACHINE
397 [ -z "$TARGET_CPU" ] && TARGET_CPU=$BUILD_CPU
398 DEVDIR_BIN="$DEVDIR/$OS.$BUILD_MACHINE/bin"
399 log_success "Determined build machine: $OS.$BUILD_MACHINE, target machine: $OS.$TARGET_MACHINE"
400
401 echo "BUILD_PLATFORM=\"$OS\"" >> $ENV
402 echo "export BUILD_PLATFORM" >> $ENV
403 echo "BUILD_PLATFORM_ARCH=\"$BUILD_MACHINE\"" >> $ENV
404 echo "export BUILD_PLATFORM_ARCH" >> $ENV
405 echo "BUILD_TARGET=\"$OS\"" >> $ENV
406 echo "export BUILD_TARGET" >> $ENV
407 echo "BUILD_TARGET_ARCH=\"$TARGET_MACHINE\"" >> $ENV
408 echo "export BUILD_TARGET_ARCH" >> $ENV
409 echo "BUILD_TARGET_CPU=\"$TARGET_CPU\"" >> $ENV
410 echo "export BUILD_TARGET_CPU" >> $ENV
411 echo "BUILD_TYPE=\"$BUILD_TYPE\"" >> $ENV
412 echo "export BUILD_TYPE" >> $ENV
413}
414
415#
416# Check for gcc with version >= 3.2.
417# We depend on a working gcc, if we fail terminate in every case.
418#
419check_gcc()
420{
421 test_header gcc
422 if check_avail "$CC" CC really; then
423 cc_ver=`$CC -dumpfullversion 2>/dev/null`
424 if [ $? -ne 0 ]; then
425 cc_ver=`$CC -dumpversion 2>/dev/null`
426 fi
427 if [ $? -ne 0 ]; then
428 log_failure "cannot execute '$CC -dumpversion'"
429 fail really
430 fi
431 if check_avail "$CXX" CXX really; then
432 cxx_ver=`$CXX -dumpfullversion 2>/dev/null`
433 if [ $? -ne 0 ]; then
434 cxx_ver=`$CXX -dumpversion 2>/dev/null`
435 fi
436 if [ $? -ne 0 ]; then
437 log_failure "cannot execute '$CXX -dumpversion'"
438 fail really
439 fi
440 cc_maj=`echo $cc_ver|cut -d. -f1`
441 cc_min=`echo $cc_ver|cut -d. -f2`
442 if [ "x$cc_ver" != "x$cxx_ver" ]; then
443 log_failure "gcc version $cc_ver does not match g++ version $cxx_ver"
444 fail really
445 elif [ $cc_maj -eq 4 -a $cc_min -eq 0 -a "$OS" = "darwin" ]; then
446 log_success "found version $cc_ver"
447 # gcc-4.0 is allowed for Darwin only
448 elif [ $cc_maj -eq 4 -a $cc_min -eq 2 -a "$OS" = "freebsd" ]; then
449 log_success "found version $cc_ver"
450 # gcc-4.2 is allowed for FreeBSD only
451 elif [ $cc_maj -lt 4 \
452 -o \( $cc_maj -eq 4 -a $cc_min -lt 4 -a "$OS" != "darwin" \) \
453 -o \( $cc_maj -eq 4 -a $cc_min -lt 2 -a "$OS" = "darwin" \) ]; then
454 log_failure "gcc version $cc_maj.$cc_min found, expected gcc 4.x or later"
455 fail really
456 else
457 log_success "found version $cc_ver"
458 fi
459 if [ "$BUILD_MACHINE" = "amd64" ]; then
460 [ -z "$CC32" ] && CC32="$CC -m32"
461 [ -z "$CXX32" ] && CXX32="$CXX -m32"
462 else
463 [ -z "$CC32" ] && CC32="$CC"
464 [ -z "$CXX32" ] && CXX32="$CXX"
465 fi
466 if [ "$BUILD_MACHINE" = "x86" -a "$TARGET_MACHINE" = "amd64" ]; then
467 [ -z "$CC64" ] && CC64="$CC -m64"
468 [ -z "$CXX64" ] && CXX64="$CXX -m64"
469 fi
470 if [ "$TARGET_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 0 ]; then
471 CC32="undefined"
472 CXX32="undefined"
473 fi
474 if [ "$CC" != "gcc" ]; then
475 cnf_append "TOOL_GCC3_CC" "$CC"
476 cnf_append "TOOL_GCC3_AS" "$CC"
477 cnf_append "TOOL_GCC3_LD" "$CC"
478 cnf_append "TOOL_GXX3_CC" "$CC"
479 cnf_append "TOOL_GXX3_AS" "$CC"
480 fi
481 if [ "$CXX" != "g++" ]; then
482 cnf_append "TOOL_GCC3_CXX" "$CXX"
483 cnf_append "TOOL_GXX3_CXX" "$CXX"
484 cnf_append "TOOL_GXX3_LD" "$CXX"
485 fi
486 if [ "$CC32" != "gcc -m32" -a "$CC32" != "undefined" ]; then
487 cnf_append "TOOL_GCC32_CC" "$CC32"
488 cnf_append "TOOL_GCC32_AS" "$CC32"
489 cnf_append "TOOL_GCC32_LD" "$CC32"
490 cnf_append "TOOL_GXX32_CC" "$CC32"
491 cnf_append "TOOL_GXX32_AS" "$CC32"
492 fi
493 if [ "$CXX32" != "g++ -m32" -a "$CXX32" != "undefined" ]; then
494 cnf_append "TOOL_GCC32_CXX" "$CXX32"
495 cnf_append "TOOL_GXX32_CXX" "$CXX32"
496 cnf_append "TOOL_GXX32_LD" "$CXX32"
497 fi
498 # this isn't not necessary, there is not such tool.
499 if [ -n "$CC64" ]; then
500 cnf_append "TOOL_GCC64_CC" "$CC64"
501 cnf_append "TOOL_GCC64_AS" "$CC64"
502 cnf_append "TOOL_GCC64_LD" "$CC64"
503 cnf_append "TOOL_GXX64_CC" "$CC64"
504 cnf_append "TOOL_GXX64_AS" "$CC64"
505 fi
506 if [ -n "$CXX64" ]; then
507 cnf_append "TOOL_GCC64_CXX" "$CXX64"
508 cnf_append "TOOL_GXX64_CXX" "$CXX64"
509 cnf_append "TOOL_GXX64_LD" "$CXX64"
510 fi
511 if [ "$CC" != "gcc" ]; then
512 if [ -n "$CC64" ]; then
513 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC64"
514 else
515 cnf_append "TOOL_Bs3Gcc64Elf64_CC" "$CC"
516 fi
517 if [ -n "$CXX64" ]; then
518 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX64"
519 else
520 cnf_append "TOOL_Bs3Gcc64Elf64_CXX" "$CXX"
521 fi
522 fi
523 # Solaris sports a 32-bit gcc/g++.
524 if [ "$OS" = "solaris" -a "$BUILD_MACHINE" = "amd64" ]; then
525 [ "$CC" = "gcc" ] && CC="gcc -m64"
526 [ "$CXX" = "g++" ] && CXX="g++ -m64"
527 fi
528 fi
529 fi
530}
531
532
533#
534# Check for the OpenWatcom compiler, needed for compiling the BIOS
535#
536# If the system has Open Watcom installed, WATCOM will be set in the
537# environment. If the user has her/his own Open Watcom install it will be
538# pointed to by on the command line, which will set the WATCOM variable.
539# The only exception is detecting OpenWatcom in tools/common/openwatcom.
540#
541check_open_watcom()
542{
543 test_header "Open Watcom"
544
545 if [ -z "$WATCOM" ]; then
546 WATCOM=`/bin/ls -rd1 $PWD/tools/common/openwatcom/* 2> /dev/null | head -1`
547 if [ -z "$WATCOM" ]; then
548 if [ $OSE -eq 0 -a $OS = "linux" ]; then
549 log_failure "Open Watcom was not found"
550 exit 1
551 fi
552 log_failure "Open Watcom was not found, using alternative BIOS sources"
553 cnf_append "VBOX_WITH_OPEN_WATCOM" ""
554 return 0;
555 fi
556 fi
557
558 case "$OS" in
559 "darwin") wc_bin="binosx";; # ??
560 "dos") wc_bin="binw";;
561 "freebsd") wc_bin="binfbsd";; # ??
562 "linux") wc_bin="binl";;
563 "netbsd") wc_bin="binnbsd";; # ??
564 "solaris") wc_bin="binsol";; # ??
565 "os2") wc_bin="binp";;
566 "win") wc_bin="binnt";;
567 *) wc_bin="binl";;
568 esac
569
570 # Check that the tools we use are there.
571 for prog in wasm wcc wlink;
572 do
573 if [ ! -f "$WATCOM/$wc_bin/$prog" ]; then
574 log_failure "$WATCOM/$wc_bin/$prog does not exist or is not a regular file."
575 fail
576 fi
577 done
578
579 # Use WASM to get the version.
580 wasm_ver=`$WATCOM/$wc_bin/wasm -? 2>&1 | sed -e '1!d' -e 's/Open Watcom Assembler Version *//'`
581 if [ -z "$wasm_ver" ]; then
582 log_failure "$WATCOM/$wc_bin/wasm -? did not produce the expected response"
583 fail
584 fi
585 log_success "found version $wasm_ver"
586 cnf_append "PATH_TOOL_OPENWATCOM" "$WATCOM"
587 cnf_append "VBOX_WITH_OPEN_WATCOM" "1"
588
589 unset wasm_ver
590 unset wc_wasm
591 unset wc_bin
592}
593
594
595#
596# Check for yasm, needed to compile assembler files
597#
598check_yasm()
599{
600 test_header yasm
601 if check_avail "$YASM" YASM; then
602 yasm_ver=`$YASM --version|grep "^yasm"|sed 's+^yasm \(.*\)+\1+'`
603 if [ $? -ne 0 ]; then
604 log_failure "yasm not found"
605 fail
606 else
607 yasm_maj=`echo $yasm_ver|cut -d. -f1`
608 yasm_min=`echo $yasm_ver|cut -d. -f2`
609 yasm_rev=`echo $yasm_ver|cut -d. -f3`
610 yasm_ver_mul=`expr $yasm_maj \* 10000 + $yasm_min \* 100 + $yasm_rev`
611 if [ $yasm_ver_mul -lt 501 ]; then
612 log_failure "found version $yasm_ver, expected at least 0.5.1"
613 fail
614 else
615 log_success "found version $yasm_ver"
616 fi
617 fi
618 fi
619}
620
621
622#
623# Check for the iasl ACPI compiler, needed to compile vbox.dsl
624#
625check_iasl()
626{
627 test_header iasl
628 if check_avail "$IASL" IASL; then
629 iasl_ver=`$IASL|grep "ASL.*version"|sed 's+^ASL.*version \([0-9]*\).*+\1+'`
630 if [ $? -ne 0 ]; then
631 log_failure "iasl not found"
632 fail
633 else
634 log_success "found version $iasl_ver"
635 cnf_append "VBOX_IASLCMD" "`which_wrapper $IASL`"
636 fi
637 fi
638}
639
640
641#
642# Check for xsltproc, needed by Main
643#
644check_xsltproc()
645{
646 if [ -n "$BUILD_LIBXSLT" ]; then
647 return 0;
648 fi
649 test_header xslt
650 if check_avail "$XSLTPROC" XSLTPROC; then
651 xsltproc_ver=`$XSLTPROC --version`
652 if [ $? -ne 0 ]; then
653 log_failure "xsltproc not found"
654 fail
655 else
656 log_success "found"
657 cnf_append "VBOX_XSLTPROC" "`which_wrapper $XSLTPROC`"
658 fi
659 fi
660}
661
662
663#
664# Check for libxml2, needed by the Runtime.
665# 2.6.24 is known to NOT work, 2.6.26 is known to work (there is no 2.6.25 release)
666#
667check_libxml2()
668{
669 if [ -z "$BUILD_LIBXML2" ]; then
670 test_header libxml2
671 if which_wrapper pkg-config > /dev/null; then
672 libxml2_ver=`pkg-config libxml-2.0 --modversion 2>> $LOG`
673 if [ $? -ne 0 ]; then
674 log_failure "libxml2 not found"
675 fail
676 else
677 FLGXML2=`pkg-config libxml-2.0 --cflags`
678 INCXML2=`strip_I "$FLGXML2"`
679 LIBXML2=`pkg-config libxml-2.0 --libs`
680 cat > $ODIR.tmp_src.cc << EOF
681#include <cstdio>
682#include <libxml/xmlversion.h>
683extern "C" int main(void)
684{
685 printf("found version %s", LIBXML_DOTTED_VERSION);
686#if LIBXML_VERSION >= 20626
687 printf(", OK.\n");
688 return 0;
689#else
690 printf(", expected version 2.6.26 or higher\n");
691 return 1;
692#endif
693}
694EOF
695 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
696 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
697 if test_execute; then
698 cnf_append "SDK_VBOX_LIBXML2_DEFS" "_REENTRANT" ## @todo get defines from --cflags
699 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
700 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
701 fi
702 fi
703 fi
704 elif which_wrapper xml2-config; then
705 libxml2_ver=`xml2-config --version`
706 if [ $? -ne 0 ]; then
707 log_failure "xml2-config not found"
708 fail
709 else
710 log_success "found version $libxml2_ver"
711 FLGXML2=`xml2-config --cflags`
712 INCXML2=`strip_I "$FLGXML2"`
713 LIBXML2=`xml2-config --libs`
714 cat > $ODIR.tmp_src.cc << EOF
715#include <cstdio>
716#include <libxml/xmlversion.h>
717extern "C" int main(void)
718{
719 printf("found version %s", LIBXML_DOTTED_VERSION);
720#if LIBXML_VERSION >= 20626
721 printf(", OK.\n");
722 return 0;
723#else
724 printf(", expected version 2.6.26 or higher\n");
725 return 1;
726#endif
727}
728EOF
729 [ -n "$INCXML2" ] && I_INCXML2=`prefix_I "$INCXML2"`
730 if test_compile "$LIBXML2 $LIBPTHREAD $I_INCXML2" xml2 xml2; then
731 if test_execute; then
732 cnf_append "SDK_VBOX_LIBXML2_DEFS" "_REENTRANT" ## @todo get defines from --cflags
733 cnf_append "SDK_VBOX_LIBXML2_INCS" "$INCXML2"
734 cnf_append "SDK_VBOX_LIBXML2_LIBS" "`strip_l "$LIBXML2"`"
735 fi
736 fi
737 fi
738 else
739 log_failure "neither pkg-config nor xml2-config found"
740 fail
741 fi
742 fi
743}
744
745
746#
747# Check for libIDL, needed by xpcom
748#
749check_libidl()
750{
751 test_header libIDL
752
753 if which_wrapper libIDL-config-2 > /dev/null; then
754 libidl_ver=`libIDL-config-2 --version`
755 if [ $? -ne 0 ]; then
756 log_failure "libIDL-config-2 not working"
757 fail
758 else
759 log_success "found version $libidl_ver"
760 cnf_append "VBOX_LIBIDL_CONFIG" \
761 "PKG_CONFIG_PATH=`libIDL-config-2 --prefix`/$LIB/pkgconfig `which_wrapper libIDL-config-2`"
762 fi
763 elif check_avail "libIDL-config" libIDL-config; then
764 libidl_ver=`libIDL-config --version`
765 if [ $? -ne 0 ]; then
766 log_failure "libIDL-config not working"
767 fail
768 else
769 log_success "found version $libidl_ver"
770 cnf_append "VBOX_LIBIDL_CONFIG" "`which_wrapper libIDL-config`"
771 fi
772 fi
773}
774
775
776#
777# Check for libdevmapper, needed by the VBoxVolInfo
778#
779check_libdevmapper()
780{
781 test_header libdevmapper
782 cat > $ODIR.tmp_src.cc << EOF
783#include <cstdio>
784extern "C" {
785#define private
786#include <libdevmapper.h>
787int main()
788{
789 char version[80];
790
791 if (!dm_get_library_version(version, sizeof(version)))
792 {
793 printf("dm_get_library_version() failed.\n");
794 return 1;
795 }
796
797 const char* v=version;
798 unsigned int major = 0, minor = 0, micro = 0;
799
800 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
801 if (*v == '.') v++;
802 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
803 if (*v == '.') v++;
804 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
805
806 printf("found version %s", version);
807 if (major*10000 + minor*100 + micro >= 10200)
808 {
809 printf(", OK.\n");
810 return 0;
811 }
812 else
813 {
814 printf(", expected version 1.02 or higher\n");
815 return 1;
816 }
817}
818}
819EOF
820 if test_compile "$LIBDEVMAPPER $INCDEVMAPPER" libdevmapper libdevmapper; then
821 if test_execute; then
822 cnf_append "VBOX_WITH_DEVMAPPER" "1"
823 fi
824 fi
825}
826
827
828#
829# Check for openssl, needed for RDP and S3
830#
831check_ssl()
832{
833 if [ -z "$BUILD_LIBSSL" ]; then
834 test_header ssl
835 cat > $ODIR.tmp_src.cc << EOF
836#include <cstdio>
837#include <openssl/opensslv.h>
838#include <openssl/ssl.h>
839extern "C" int main(void)
840{
841 printf("found version %s", OPENSSL_VERSION_TEXT);
842 SSL_library_init();
843#if OPENSSL_VERSION_NUMBER >= 0x10001000
844 printf(", OK.\n");
845 return 0;
846#else
847 printf(", expected version 1.0.1 or higher\n");
848 return 1;
849#endif
850}
851EOF
852 if test_compile "$INCCRYPTO $LIBCRYPTO" libcrypto openssl; then
853 if test_execute nofatal; then
854 cnf_append "SDK_VBOX_OPENSSL_INCS" "`strip_I "$INCCRYPTO"`"
855 cnf_append "SDK_VBOX_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
856 cnf_append "SDK_VBOX_BLD_OPENSSL_LIBS" "`strip_l "$LIBCRYPTO"`"
857 fi
858 fi
859 fi
860}
861
862
863#
864# Check for pthread, needed by VBoxSVC, frontends, ...
865#
866check_pthread()
867{
868 test_header pthread
869 cat > $ODIR.tmp_src.cc << EOF
870#include <cstdio>
871#include <pthread.h>
872extern "C" int main(void)
873{
874 pthread_mutex_t mutex;
875 if (pthread_mutex_init(&mutex, NULL)) {
876 printf("pthread_mutex_init() failed\n");
877 return 1;
878 }
879 if (pthread_mutex_lock(&mutex)) {
880 printf("pthread_mutex_lock() failed\n");
881 return 1;
882 }
883 if (pthread_mutex_unlock(&mutex)) {
884 printf("pthread_mutex_unlock() failed\n");
885 return 1;
886 }
887 printf("found, OK.\n");
888}
889EOF
890 if test_compile $LIBPTHREAD pthread pthread; then
891 if test_execute; then
892 cnf_append "LIB_PTHREAD" "`strip_l "$LIBPTHREAD"`"
893 fi
894 fi
895}
896
897
898#
899# Check for zlib, needed by VBoxSVC, Runtime, ...
900#
901check_z()
902{
903 test_header zlib
904 cat > $ODIR.tmp_src.cc << EOF
905#include <cstdio>
906#include <zlib.h>
907extern "C" int main(void)
908{
909 printf("found version %s", ZLIB_VERSION);
910#if ZLIB_VERNUM >= 0x1210
911 printf(", OK.\n");
912 return 0;
913#else
914 printf(", expected version 1.2.1 or higher\n");
915 return 1;
916#endif
917}
918EOF
919 [ -n "$INCZ" ] && I_INCZ=`prefix_I "$INCZ"`
920 if test_compile "$LIBZ $I_INCZ" zlib zlib; then
921 if test_execute; then
922 echo "if1of (\$(KBUILD_TARGET),darwin freebsd haiku linux)" >> $CNF
923 cnf_append " SDK_VBOX_ZLIB_LIBS" "`strip_l "$LIBZ"`"
924 cnf_append " SDK_VBOX_ZLIB_INCS" "$INCZ"
925 echo "endif" >> $CNF
926 fi
927 fi
928}
929
930
931#
932# Check for libpng, needed by kchmviewer
933#
934check_png()
935{
936 test_header libpng
937 cat > $ODIR.tmp_src.cc << EOF
938#include <cstdio>
939#include <png.h>
940extern "C" int main(void)
941{
942 printf("found version %s", PNG_LIBPNG_VER_STRING);
943#if PNG_LIBPNG_VER >= 10205
944 printf(", OK.\n");
945 return 0;
946#else
947 printf(", expected version 1.2.5 or higher\n");
948 return 1;
949#endif
950}
951EOF
952 [ -n "$INCPNG" ] && I_INCPNG=`prefix_I "$INCPNG"`
953 if test_compile "$LIBPNG $I_INCPNG" libpng libpng; then
954 if test_execute; then
955 cnf_append "SDK_VBOX_LIBPNG_LIBS" "`strip_l "$LIBPNG"`"
956 cnf_append "SDK_VBOX_LIBPNG_INCS" "$INCPNG"
957 fi
958 fi
959}
960
961#
962# Check for libvncserver, needed for VNC in OSE
963#
964check_vncserver()
965{
966 test_header libvncserver
967 cat > $ODIR.tmp_src.cc <<EOF
968#include <cstdio>
969#include <rfb/rfbconfig.h>
970
971extern "C" int main()
972{
973 const char* v=LIBVNCSERVER_VERSION;
974 unsigned int major = 0, minor = 0, micro = 0;
975
976 for (; *v !='.' && *v != '\0'; v++) major = major*10 + *v-'0';
977 if (*v == '.') v++;
978 for (; *v !='.' && *v != '\0'; v++) minor = minor*10 + *v-'0';
979 if (*v == '.') v++;
980 for (; *v !='.' && *v != '\0'; v++) micro = micro*10 + *v-'0';
981
982 printf("found version %s", LIBVNCSERVER_PACKAGE_VERSION);
983 if (major*10000 + minor*100 + micro >= 900)
984 {
985 printf(", OK.\n");
986 return 0;
987 }
988 else
989 {
990 printf(", expected version 0.9 or higher\n");
991 return 1;
992 }
993}
994EOF
995 if test_compile "$LIBVNCSERVER $INCVNCSERVER" libvncserver libvncserver; then
996 if test_execute; then
997 cnf_append "VBOX_WITH_EXTPACK_VNC" "1"
998 fi
999 fi
1000}
1001
1002#
1003# Check for libcurl, needed by S3
1004#
1005check_curl()
1006{
1007 if [ -z "$BUILD_LIBCURL" ]; then
1008 test_header libcurl
1009 cat > $ODIR.tmp_src.cc << EOF
1010#include <cstdio>
1011#include <curl/curl.h>
1012extern "C" int main(void)
1013{
1014 printf("found version %s", LIBCURL_VERSION);
1015#if 10000*LIBCURL_VERSION_MAJOR + 100*LIBCURL_VERSION_MINOR + LIBCURL_VERSION_PATCH >= 71901
1016 printf(", OK.\n");
1017 return 0;
1018#else
1019 printf(", expected version 7.19.1 or higher\n");
1020 return 1;
1021#endif
1022}
1023EOF
1024 [ -n "$INCCURL" ] && I_INCCURL=`prefix_I "$INCCURL"`
1025 if test_compile "$LIBCURL $I_INCCURL" libcurl libcurl; then
1026 if test_execute; then
1027 cnf_append "SDK_VBOX_LIBCURL_LIBS" "`strip_l "$LIBCURL"`"
1028 cnf_append "SDK_VBOX_LIBCURL_INCS" "$INCCURL"
1029 fi
1030 fi
1031 fi
1032}
1033
1034
1035#
1036# Check for pam, needed by VRDPAuth
1037# Version 79 was introduced in 9/2005, do we support older versions?
1038# Debian/sarge uses 76
1039# OpenSUSE comes with 0.99.xxx where they changed the versioning scheme.
1040#
1041check_pam()
1042{
1043 test_header pam
1044 cat > $ODIR.tmp_src.cc << EOF
1045#include <cstdio>
1046#include <security/pam_appl.h>
1047extern "C" int main(void)
1048{
1049 printf("found version %d", __LIBPAM_VERSION);
1050 if (__LIBPAM_VERSION >= 76)
1051 {
1052 printf(", OK.\n");
1053 return 0;
1054 }
1055 else
1056 {
1057 printf(", expected version 76 or higher\n");
1058 return 1;
1059 }
1060}
1061EOF
1062 if test_compile "-lpam" pam pam nofatal; then
1063 if test_execute nofatal; then
1064 return 0;
1065 fi
1066 fi
1067 echo "pam0.x not found"
1068 test_header linux_pam
1069 cat > $ODIR.tmp_src.cc << EOF
1070#include <cstdio>
1071#include <security/pam_appl.h>
1072extern "C" int main(void)
1073{
1074 printf("found version %d.%d", __LINUX_PAM__, __LINUX_PAM_MINOR__);
1075 if (__LINUX_PAM__ >= 1)
1076 {
1077 printf(", OK.\n");
1078 return 0;
1079 }
1080 else
1081 {
1082 printf(", expected version 1.0 or higher\n");
1083 return 1;
1084 }
1085}
1086EOF
1087 if test_compile "-lpam" pam pam; then
1088 test_execute
1089 fi
1090}
1091
1092
1093#
1094# Check for the SDL library, needed by VBoxSDL and VirtualBox
1095# We depend at least on version 1.2.7
1096#
1097check_sdl()
1098{
1099 test_header SDL
1100 if [ "$OS" = "darwin" ]; then
1101 if [ -f "/System/Library/Frameworks/SDL.framework/SDL" ]; then
1102 PATH_SDK_LIBSDL="/System/Library/Frameworks/SDL.framework"
1103 elif [ -f "/Library/Frameworks/SDL.framework/SDL" ]; then
1104 PATH_SDK_LIBSDL="/Library/Frameworks/SDL.framework"
1105 fi
1106 if [ -n "$PATH_SDK_LIBSDL" ]; then
1107 foundsdl=1
1108 INCSDL="$PATH_SDK_LIBSDL/Headers"
1109 FLDSDL="-framework SDL"
1110 else
1111 log_failure "SDL framework not found"
1112 fail
1113 fi
1114 else
1115 if which_wrapper sdl-config > /dev/null; then
1116 FLGSDL=`sdl-config --cflags`
1117 INCSDL=`strip_I "$FLGSDL"`
1118 LIBSDL=`sdl-config --libs`
1119 LIBSDLMAIN="-lSDLmain"
1120 FLDSDL=
1121 foundsdl=1
1122 fi
1123 fi
1124 [ "$OS" = "linux" -o "$OS" = "darwin" -o "$OS" = "solaris" ] && LIBSDLMAIN=""
1125 if [ -n "$foundsdl" ]; then
1126 cat > $ODIR.tmp_src.cc << EOF
1127#include <cstdio>
1128#include <SDL.h>
1129#include <SDL_main.h>
1130#undef main
1131extern "C" int main(int argc, char** argv)
1132{
1133 printf("found version %d.%d.%d",
1134 SDL_MAJOR_VERSION, SDL_MINOR_VERSION, SDL_PATCHLEVEL);
1135#if SDL_VERSION_ATLEAST(1,2,7)
1136 printf(", OK.\n");
1137 return 0;
1138#else
1139 printf(", expected version 1.2.7 or higher\n");
1140 return 1;
1141#endif
1142}
1143EOF
1144 [ -n "$INCSDL" ] && I_INCSDL=`prefix_I "$INCSDL"`
1145 if test_compile "$LIBSDL $LIBSDLMAIN $I_INCSDL $FLDSDL" SDL SDL; then
1146 if test_execute; then
1147 cnf_append "LIB_SDK_LIBSDL_SDL" "`strip_l "$LIBSDL"`"
1148 cnf_append "SDK_LIBSDL_LIBPATH" "`strip_L "$LIBSDL"`"
1149 cnf_append "LIB_SDK_LIBSDL_SDLMAIN" "`strip_l "$LIBSDLMAIN"`"
1150 [ -n "$INCSDL" ] && cnf_append "SDK_LIBSDL_INCS" "$INCSDL"
1151 [ -n "$FLDSDL" ] && cnf_append "SDK_LIBSDL_LDFLAGS" "$FLDSDL"
1152 fi
1153 fi
1154 else
1155 log_failure "SDL not found (can be disabled using --disable-sdl)"
1156 fail
1157 fi
1158}
1159
1160
1161#
1162# Check for the SDL_ttf library, needed by VBoxSDL (secure label)
1163#
1164check_sdl_ttf()
1165{
1166 test_header SDL_ttf
1167 cat > $ODIR.tmp_src.cc << EOF
1168#include <cstdio>
1169#include <SDL_ttf.h>
1170#ifndef SDL_TTF_MAJOR_VERSION
1171#define SDL_TTF_MAJOR_VERSION TTF_MAJOR_VERSION
1172#define SDL_TTF_MINOR_VERSION TTF_MINOR_VERSION
1173#define SDL_TTF_PATCHLEVEL TTF_PATCHLEVEL
1174#endif
1175extern "C" int main(void)
1176{
1177 printf("found version %d.%d.%d",
1178 SDL_TTF_MAJOR_VERSION, SDL_TTF_MINOR_VERSION, SDL_TTF_PATCHLEVEL);
1179#if 10000*SDL_TTF_MAJOR_VERSION + 100*SDL_TTF_MINOR_VERSION + SDL_TTF_PATCHLEVEL >= 20006
1180 printf(", OK.\n");
1181 return 0;
1182#else
1183 printf(", expected version 2.0.6 or higher\n");
1184 return 1;
1185#endif
1186}
1187EOF
1188 if test_compile "-lSDL_ttf $I_INCSDL" SDL_ttf SDL_ttf nofatal; then
1189 test_execute nofatal || \
1190 cnf_append "VBOX_WITH_SECURELABEL" ""
1191 else
1192 echo "not found -- disabling VBoxSDL secure label."
1193 cnf_append "VBOX_WITH_SECURELABEL" ""
1194 fi
1195}
1196
1197
1198#
1199# Check for libasound, needed by the ALSA audio backend
1200#
1201check_alsa()
1202{
1203 test_header ALSA
1204 cat > $ODIR.tmp_src.cc << EOF
1205#include <cstdio>
1206#include <alsa/asoundlib.h>
1207extern "C" int main(void)
1208{
1209 printf("found version %d.%d.%d",
1210 SND_LIB_MAJOR, SND_LIB_MINOR, SND_LIB_SUBMINOR);
1211#if 10000*SND_LIB_MAJOR + 100*SND_LIB_MINOR + SND_LIB_SUBMINOR >= 10014
1212 printf(", OK.\n");
1213 return 0;
1214#else
1215 printf(", expected version 1.0.14 or higher\n");
1216 return 1;
1217#endif
1218}
1219EOF
1220 if test_compile "-lasound" asound asound; then
1221 test_execute
1222 fi
1223}
1224
1225
1226#
1227# Check for PulseAudio
1228#
1229check_pulse()
1230{
1231 test_header "PulseAudio"
1232 cat > $ODIR.tmp_src.cc << EOF
1233#include <cstdio>
1234#include <pulse/version.h>
1235extern "C" int main(void)
1236{
1237 printf("found version %s API version %d", pa_get_headers_version(), PA_API_VERSION);
1238#if PA_API_VERSION >= 9
1239 printf(", OK.\n");
1240 return 0;
1241#else
1242 printf(", expected version 0.9.0 (API version 9) or higher\n");
1243 return 1;
1244#endif
1245}
1246EOF
1247 if test_compile "$INCPULSE $LIBPULSE -lpulse" pulse pulse nofatal; then
1248 if test_execute nofatal; then
1249 cnf_append "VBOX_WITH_AUDIO_PULSE" "1"
1250 else
1251 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
1252 else
1253 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
1254 fi
1255}
1256
1257
1258#
1259# Check for the X libraries (Xext, X11)
1260#
1261check_x()
1262{
1263 test_header "X libraries"
1264 cat > $ODIR.tmp_src.cc << EOF
1265#include <cstdio>
1266#include <X11/Xlib.h>
1267extern "C" int main(void)
1268{
1269 Display *dpy;
1270 int scrn_num;
1271 Screen *scrn;
1272 Window win;
1273
1274 dpy = XOpenDisplay(NULL);
1275 scrn_num = DefaultScreen(dpy);
1276 scrn = ScreenOfDisplay(dpy, scrn_num);
1277 win = XCreateWindow(dpy, RootWindowOfScreen(scrn), 0, 0, 100, 100,
1278 0, 16, InputOutput, CopyFromParent, 0, NULL);
1279 XDestroyWindow(dpy, win);
1280 XCloseDisplay(dpy);
1281}
1282EOF
1283 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1284 if test_compile "$LIBX11 $I_INCX11" Xlibs Xlibs; then
1285 log_success "found"
1286 fi
1287}
1288
1289
1290#
1291# Check for the Xcursor library, needed by VBoxSDL.
1292#
1293check_xcursor()
1294{
1295 test_header Xcursor
1296 cat > $ODIR.tmp_src.cc << EOF
1297#include <cstdio>
1298#include <X11/Xlib.h>
1299#include <X11/Xcursor/Xcursor.h>
1300extern "C" int main(void)
1301{
1302 XcursorImage *cursor = XcursorImageCreate (10, 10);
1303 XcursorImageDestroy(cursor);
1304 return 0;
1305}
1306EOF
1307 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1308 if test_compile "$LIBX11 $LIBXCURSOR $I_INCX11" Xcursor Xcursor; then
1309 log_success "found"
1310 cnf_append "VBOX_XCURSOR_LIBS" "`strip_l "$LIBXCURSOR"`"
1311 fi
1312}
1313
1314
1315#
1316# Check for the Xinerama library, needed by the Qt GUI
1317#
1318check_xinerama()
1319{
1320 test_header Xinerama
1321 cat > $ODIR.tmp_src.cc << EOF
1322#include <X11/Xlib.h>
1323#include <X11/extensions/Xinerama.h>
1324extern "C" int main(void)
1325{
1326 Display *dpy;
1327 Bool flag;
1328 dpy = XOpenDisplay(NULL);
1329 if (dpy)
1330 {
1331 flag = XineramaIsActive(dpy);
1332 XCloseDisplay(dpy);
1333 }
1334}
1335EOF
1336 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1337 if test_compile "$LIBX11 $LIBXINERAMA $I_INCX11" Xinerama Xinerama; then
1338 log_success "found"
1339 fi
1340}
1341
1342
1343#
1344# Check for the Xinerama library, needed by the Qt GUI
1345#
1346check_xrandr()
1347{
1348 test_header Xrandr
1349 cat > $ODIR.tmp_src.cc << EOF
1350#include <X11/Xlib.h>
1351#include <X11/extensions/Xrandr.h>
1352extern "C" int main(void)
1353{
1354 Display *dpy;
1355 Bool flag;
1356 int major, minor;
1357 dpy = XOpenDisplay(NULL);
1358 if (dpy)
1359 {
1360 flag = XRRQueryVersion(dpy, &major, &minor);
1361 XCloseDisplay(dpy);
1362 }
1363}
1364EOF
1365 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1366 if test_compile "$LIBX11 $LIBXRANDR $I_INCX11" Xrandr Xrandr; then
1367 log_success "found"
1368 fi
1369}
1370
1371
1372#
1373# Check for OpenGL
1374#
1375check_opengl()
1376{
1377 # On darwin this is a on/off decision only
1378 if [ "$OS" = "darwin" ]; then
1379 test_header "OpenGL support"
1380 echo "enabled"
1381 cnf_append "VBOX_WITH_CROGL" "1"
1382 else
1383 check_xmu
1384 check_mesa
1385 fi
1386}
1387
1388
1389#
1390# Check for the Xmu library, needed by OpenGL
1391#
1392check_xmu()
1393{
1394 test_header Xmu
1395 cat > $ODIR.tmp_src.cc << EOF
1396#include <cstdio>
1397#include <X11/Xatom.h>
1398#include <X11/Xlib.h>
1399#include <X11/Xutil.h>
1400#include <X11/Xmu/StdCmap.h>
1401extern "C" int main(void)
1402{
1403 Display *dpy;
1404 int scrn_num;
1405 Screen *scrn;
1406
1407 dpy = XOpenDisplay(NULL);
1408 if (dpy)
1409 {
1410 scrn_num = DefaultScreen(dpy);
1411 scrn = ScreenOfDisplay(dpy, scrn_num);
1412 Status status = XmuLookupStandardColormap(dpy, RootWindowOfScreen(scrn), 0,
1413 24, XA_RGB_DEFAULT_MAP, False, True);
1414 printf("Status = %x\n", status);
1415 XCloseDisplay(dpy);
1416 }
1417 return 0;
1418}
1419EOF
1420 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1421 if test_compile "$LIBX11 $LIBXMU $I_INCX11" Xmu Xmu; then
1422 log_success "found"
1423 cnf_append "VBOX_XMU_LIBS" "`strip_l "$LIBXMU"`"
1424 fi
1425}
1426
1427#
1428# Check for Mesa, needed by OpenGL
1429#
1430check_mesa()
1431{
1432 test_header "Mesa / GLU"
1433 cat > $ODIR.tmp_src.cc << EOF
1434#include <cstdio>
1435#include <X11/Xlib.h>
1436#include <GL/glx.h>
1437#include <GL/glu.h>
1438extern "C" int main(void)
1439{
1440 Display *dpy;
1441 int major, minor;
1442
1443 dpy = XOpenDisplay(NULL);
1444 if (dpy)
1445 {
1446 Bool glx_version = glXQueryVersion(dpy, &major, &minor);
1447 XCloseDisplay(dpy);
1448 if (glx_version)
1449 {
1450 printf("found version %u.%u, OK.\n", major, minor);
1451 return 0;
1452 }
1453 }
1454 printf("found (inactive), OK.\n");
1455 return 0;
1456}
1457EOF
1458 [ -n "$INCX11" ] && I_INCX11=`prefix_I "$INCX11"`
1459 if test_compile "$LIBX11 $MESA $I_INCX11" Mesa Mesa; then
1460 [ $PASSIVE_MESA -eq 1 ] && unset DISPLAY
1461 test_execute
1462 fi
1463}
1464
1465
1466#
1467# Check for the Qt5 library, needed by the VirtualBox frontend
1468#
1469# Currently not fatal.
1470#
1471check_qt5()
1472{
1473 foundqt5=
1474 test_header Qt5
1475 cat > $ODIR.tmp_src.cc << EOF
1476#include <QtGlobal>
1477extern "C" int main(void)
1478{
1479EOF
1480 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1481 cat >> $ODIR.tmp_src.cc << EOF
1482 return 0;
1483#else
1484 return 1;
1485#endif
1486}
1487EOF
1488 if [ "$OS" = "darwin" ]; then
1489 # First check if there is the internal version of Qt. If yes nothing else
1490 # has to be done.
1491 QT_INTERNAL=`/bin/ls -rd1 $PWD/tools/$BUILD_TARGET.$BUILD_PLATFORM_ARCH/qt/* 2> /dev/null`
1492 for t in $QT_INTERNAL; do
1493 if [ -f "$t/Frameworks/QtCoreVBox.framework/QtCoreVBox" ]; then
1494 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1495 log_success "use internal version"
1496 return
1497 fi
1498 done
1499 # Now try the user provided directory and some of the standard directories.
1500 QT_TRIES="$QT5DIR /System/Library /Library"
1501 for t in $QT_TRIES; do
1502 if [ -f "$t/Frameworks/QtCore.framework/QtCore" ]; then
1503 PATH_SDK_QT5="$t"
1504 break
1505 fi
1506 done
1507 # Add the necessary params for building the test application
1508 if [ -n "$PATH_SDK_QT5" ]; then
1509 foundqt5=1
1510 INCQT5=-I$PATH_SDK_QT5/Frameworks/QtCore.framework/Headers
1511 LIBQT5=-F$PATH_SDK_QT5/Frameworks
1512 FLGQT5="-framework QtCore"
1513 else
1514 log_failure "Qt5 framework not found (can be disabled using --disable-qt)"
1515 fail
1516 fi
1517 else # !darwin
1518 if [ $QT5DIR_PKGCONFIG -eq 1 ]; then
1519 # Default is to use pkg-config:
1520 if which_wrapper pkg-config > /dev/null; then
1521 qt5_ver=`pkg-config Qt5Core --modversion 2>> $LOG`
1522 if [ $? -eq 0 ]; then
1523 echo "(Qt5 from pkg-config)" >> $LOG
1524 FLGQT5=`pkg-config Qt5Core --cflags`
1525 # gcc 4.8 is able to compile with C++11 (see also VBOX_GCC_std in Config.kmk)
1526 [ $cc_maj -eq 4 -a $cc_min -eq 8 ] && FLGQT5="$FLGQT5 -std=c++11"
1527 INCQT5=`strip_I "$FLGQT5"`
1528 LIBDIR5=`pkg-config Qt5Core --variable=libdir`
1529 LIBQT5=`pkg-config Qt5Core --libs`
1530 LIBQT5="-L$LIBDIR5 $LIBQT5"
1531 TOOLQT5=`pkg-config Qt5Core --variable=prefix`
1532 TOOLQT5BIN=`pkg-config Qt5Core --variable=host_bins`
1533 if test_compile "$LIBQT5 $LIBPTHREAD $FLGQT5" qt5 qt5 nofatal; then
1534 test_execute_path "`strip_L "$LIBQT5"`" nofatal && foundqt5=3 # pkg-config
1535 fi
1536 fi
1537 else
1538 log_failure "pkg-config not found"
1539 fail
1540 fi
1541 fi
1542 if [ -z "$foundqt5" ]; then
1543 # Do it the old way (e.g. user has specified QT5DIR):
1544 for q in $QT5DIR "$PWD/tools/linux.$TARGET_MACHINE"/qt/v5.*; do
1545 echo "(Qt5 from '$q')" >> $LOG
1546 INCQT5="$q/include $q/include/QtCore"
1547 FLGQT5="-DQT_SHARED"
1548 I_INCQT5=`prefix_I "$INCQT5"`
1549 LIBQT5="-L$q/lib -lQt5CoreVBox"
1550 TOOLQT5="$q"
1551 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1552 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1553 foundqt5=2 # internal
1554 break;
1555 fi
1556 LIBQT5="-L$q/lib -lQt5Core"
1557 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal &&
1558 test_execute_path "`strip_L "$LIBQT5"`" nofatal; then
1559 foundqt5=1 # no pkg-config, Qt directory
1560 break;
1561 fi
1562 done
1563 fi
1564 fi
1565 if [ -n "$foundqt5" ]; then
1566 # We decided which version of Qt to use, now enforce the version requirement:
1567 cat > $ODIR.tmp_src.cc << EOF
1568#include <cstdio>
1569#include <QtGlobal>
1570extern "C" int main(void)
1571{
1572 printf("found version %s", QT_VERSION_STR);
1573EOF
1574 echo "#if QT_VERSION >= $(($QT5MAJ*65536+$QT5MIN*256))" >> $ODIR.tmp_src.cc
1575 cat >> $ODIR.tmp_src.cc << EOF
1576 printf(", OK.\n");
1577 return 0;
1578#else
1579EOF
1580echo " printf(\", expected version $QT5MAJ.$QT5MIN or higher\\\\n\");" >> $ODIR.tmp_src.cc
1581 cat >> $ODIR.tmp_src.cc << EOF
1582 return 1;
1583#endif
1584}
1585EOF
1586 [ -n "$INCQT5" ] && I_INCQT5=`prefix_I "$INCQT5"`
1587 if test_compile "$LIBQT5 $LIBPTHREAD $I_INCQT5 $FLGQT5" qt5 qt5 nofatal; then
1588 if test_execute_path "`strip_L "$LIBQT5"`"; then
1589 if [ "$OS" = "darwin" ]; then
1590 # Successful build & run the test application so add the necessary
1591 # params to AutoConfig.kmk:
1592 cnf_append "PATH_SDK_QT5_INC" "$PATH_SDK_QT5/Frameworks"
1593 cnf_append "PATH_SDK_QT5_LIB" "$PATH_SDK_QT5/Frameworks"
1594 cnf_append "PATH_SDK_QT5" "$PATH_SDK_QT5/Frameworks"
1595 # Check for the moc tool in the Qt directory found & some standard
1596 # directories.
1597 for q in $PATH_SDK_QT5 /usr /Developer/Tools/Qt; do
1598 if which_wrapper "$q/bin/moc" > /dev/null; then
1599 cnf_append "PATH_TOOL_QT5_BIN" "$q/bin"
1600 fi
1601 done
1602 else
1603 # Strip .../QtCore as we add components ourself:
1604 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\)/QtCore|\1|g; s| $||g'`
1605 # store only the first path, remove all other paths
1606 # most likely pkg-config gave us -I/usr/include/qt5 -I/usr/include/qt5/QtCore
1607 INCQT5=`echo "$INCQT5"|$KBUILD_SED 's|\([^ ]*\) .*|\1|'`
1608 cnf_append "VBOX_PATH_QT_LIB" "`strip_L "$LIBQT5"`"
1609 cnf_append "PATH_SDK_QT5_INC" "$INCQT5"
1610 # This is not quite right since the qt libpath does not have to be first...
1611 cnf_append "PATH_SDK_QT5_LIB" '$'"(firstword `strip_L "$LIBQT5"`)"
1612 if [ "$foundqt5" = "2" ]; then
1613 cnf_append "VBOX_WITH_ORACLE_QT" "1"
1614 fi
1615 if [ "$foundqt5" != "3" ]; then
1616 TOOLQT5BIN="$TOOLQT5/bin"
1617 fi
1618 test_header "Qt5 devtools"
1619 # Try it with a suffix, some platforms use that
1620 if which_wrapper "$TOOLQT5BIN/moc-qt5" > /dev/null; then
1621 QT5BINSUFF="-qt5"
1622 else
1623 QT5BINSUFF=""
1624 fi
1625 moc_ver=`$TOOLQT5BIN/moc$QT5BINSUFF -v 2>&1|sed 's+^.*(Qt \(.*\))+\1+'`
1626 if [ $? -ne 0 ]; then
1627 log_failure "moc$QT5BINSUFF not working"
1628 fail
1629 else
1630 log_success "found version $moc_ver"
1631 cnf_append "VBOX_PATH_QT" "$TOOLQT5"
1632 cnf_append "PATH_SDK_QT5" "$TOOLQT5"
1633 cnf_append "PATH_TOOL_QT5_BIN" "$TOOLQT5BIN"
1634 [ -n "$QT5BINSUFF" ] && cnf_append "TOOL_QT5_BIN_SUFF" "$QT5BINSUFF"
1635 fi
1636 fi
1637 fi
1638 else
1639 log_failure "qt5 not working"
1640 fail
1641 fi
1642 else
1643 log_failure "qt5 not found"
1644 fail
1645 fi
1646}
1647
1648
1649#
1650# Check for libopus
1651#
1652check_libopus()
1653{
1654 if [ -z "$BUILD_LIBOPUS" ]; then
1655 test_header libopus
1656 if which_wrapper pkg-config > /dev/null; then
1657 libopus_ver=`pkg-config opus --modversion 2>> $LOG`
1658 if [ $? -eq 0 ]; then
1659 FLGOPUS=`pkg-config opus --cflags`
1660 INCOPUS=`strip_I "$FLGOPUS"`
1661 LIBOPUS=`pkg-config opus --libs`
1662 fi
1663 cat > $ODIR.tmp_src.cc << EOF
1664#include <cstdio>
1665#include <opus/opus.h>
1666extern "C" int main(void)
1667{
1668 OpusEncoder *test;
1669 printf("found, OK.\n");
1670}
1671EOF
1672 [ -n "$INCOPUS" ] && I_INCOPUS=`prefix_I "$INCOPUS"`
1673 if test_compile "$LIBOPUS $I_INCOPUS" opus opus; then
1674 if test_execute; then
1675 cnf_append "SDK_VBOX_OPUS_INCS" "$INCOPUS"
1676 cnf_append "SDK_VBOX_OPUS_LIBS" "`strip_l "$LIBOPUS"`"
1677 fi
1678 fi
1679 fi
1680 fi
1681}
1682
1683
1684#
1685# Check for libvpx
1686#
1687check_vpx()
1688{
1689 if [ -z "$BUILD_LIBVPX" ]; then
1690 test_header libvpx
1691 if which_wrapper pkg-config > /dev/null; then
1692 libvpx_ver=`pkg-config vpx --modversion 2>> $LOG`
1693 if [ $? -eq 0 ]; then
1694 FLGVPX=`pkg-config vpx --cflags`
1695 INCVPX=`strip_I "$FLGVPX"`
1696 LIBVPX=`pkg-config vpx --libs`
1697 fi
1698 cat > $ODIR.tmp_src.cc << EOF
1699#include <cstdio>
1700#include <vpx/vpx_codec.h>
1701extern "C" int main(void)
1702{
1703 int version = vpx_codec_version();
1704 int verMajor = VPX_VERSION_MAJOR(version);
1705 int verMinor = VPX_VERSION_MINOR(version);
1706 int verPatch = VPX_VERSION_PATCH(version);
1707 printf("found version %d.%d.%d", verMajor, verMinor, verPatch);
1708 if ( verMajor == 1 && verMinor >= 0
1709 || verMajor == 0 && verMinor == 9 && verPatch >= 5)
1710 {
1711 printf(", OK.\n");
1712 return 0;
1713 }
1714 else
1715 {
1716 printf(", expected version 0.9.5 or higher\n");
1717 return 1;
1718 }
1719}
1720EOF
1721 [ -n "$INCVPX" ] && I_INCVPX=`prefix_I "$INCVPX"`
1722 if test_compile "$LIBVPX $I_INCVPX" vpx vpx; then
1723 if test_execute; then
1724 cnf_append "SDK_VBOX_VPX_INCS" "$INCVPX"
1725 cnf_append "SDK_VBOX_VPX_LIBS" "`strip_l "$LIBVPX"`"
1726 fi
1727 fi
1728 fi
1729 fi
1730}
1731
1732
1733#
1734# Check whether static libstdc++ is installed. This library is required
1735# for the Linux guest additions.
1736#
1737check_staticlibstdcxx()
1738{
1739 test_header "static stc++ library"
1740 libstdcxx=`$CXX -print-file-name=libstdc++.a`
1741 cat > $ODIR.tmp_src.cc << EOF
1742#include <string>
1743
1744extern "C" int main(void)
1745{
1746 std::string s = "test";
1747 return 0;
1748}
1749EOF
1750 if test_compile "$libstdcxx" libstdc++ libstdc++; then
1751 log_success "found"
1752 fi
1753}
1754
1755
1756#
1757# Check for Linux sources
1758#
1759check_linux()
1760{
1761 test_header "Linux kernel sources"
1762 cat > $ODIR.tmp_src.c << EOF
1763#include <linux/version.h>
1764int printf(const char *format, ...);
1765int main(void)
1766{
1767 printf("found version %d.%d.%d", LINUX_VERSION_CODE / 65536,
1768 (LINUX_VERSION_CODE % 65536) / 256,
1769 LINUX_VERSION_CODE % 256);
1770#if LINUX_VERSION_CODE > KERNEL_VERSION(2,4,0)
1771 printf(", OK.\n");
1772 return 0;
1773#else
1774 printf(", expected version 2.4.0 or higher\n");
1775 return 1;
1776#endif
1777}
1778EOF
1779 echo "compiling the following source file:" >> $LOG
1780 cat $ODIR.tmp_src.c >> $LOG
1781 echo "using the following command line:" >> $LOG
1782 echo "$CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include " \
1783 "-I$LINUX/include/generated/uapi" >> $LOG
1784 $CC -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c -nostdinc -I$LINUX/include \
1785 -I$LINUX/include/generated/uapi >> $LOG 2>&1
1786 if [ $? -ne 0 ]; then
1787 echo
1788 echo " Linux kernel headers not found at $LINUX"
1789 echo " Check the file $LOG for detailed error information."
1790 fail
1791 else
1792 if test_execute; then
1793 cnf_append "VBOX_LINUX_SRC" "`cd $LINUX ; pwd`"
1794 fi
1795 fi
1796}
1797
1798#
1799# Check for kchmviewer, needed to display the online help
1800# (unused as we ship kchmviewer)
1801#
1802check_kchmviewer()
1803{
1804 test_header kchmviewer
1805 if check_avail "$KCHMVIEWER" KCHMVIEWER; then
1806 kchmviewer_ver=`$KCHMVIEWER --version|grep "^KchmViewer:"|sed 's+^KchmViewer: \(.*\)+\1+'`
1807 if [ $? -ne 0 ]; then
1808 log_failure "kchmviewer not working"
1809 fail
1810 else
1811 log_success "found version $kchmviewer_ver"
1812 fi
1813 fi
1814}
1815
1816
1817#
1818# Check for the kBuild tools, we don't support GNU make
1819#
1820check_kbuild()
1821{
1822 test_header kBuild
1823 if which_wrapper "$KBUILDDIR/bin/$OS.$BUILD_MACHINE/kmk" > /dev/null; then
1824 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.$BUILD_MACHINE"
1825 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1826 echo "export PATH_KBUILD" >> $ENV
1827 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1828 echo "export PATH_DEVTOOLS" >> $ENV
1829 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"" >> $ENV
1830 echo "export PATH_KBUILD_BIN" >> $ENV
1831 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1832 if [ "$OS" = "solaris" ]; then
1833 # Because of sh being non-default shell in Solaris we need to export PATH again when
1834 # sourcing env.sh. Simply exporting from ./configure does not export PATH correctly.
1835 echo "PATH=\"$ORGPATH\"" >> $ENV
1836 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1837 echo "echo \"\$PATH\" | /usr/sfw/bin/ggrep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1838 else
1839 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1840 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1841 fi
1842 echo "export PATH" >> $ENV
1843 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1844 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1845 elif [ "$OS.$BUILD_MACHINE" = "darwin.amd64" ]; then
1846 # Currently there are no amd64 kBuild bins. So use the x86 variant in any case.
1847 KBUILDDIR_BIN="$KBUILDDIR/bin/$OS.x86"
1848 echo "PATH_KBUILD=\"`cd $KBUILDDIR ; pwd`\"" >> $ENV
1849 echo "export PATH_KBUILD" >> $ENV
1850 echo "PATH_DEVTOOLS=\"$DEVDIR\"" >> $ENV
1851 echo "export PATH_DEVTOOLS" >> $ENV
1852 echo "path_kbuild_bin=\"\$PATH_KBUILD/bin/\$BUILD_TARGET.x86\"" >> $ENV
1853 echo "PATH_KBUILD_BIN=\"\$path_kbuild_bin\"" >> $ENV
1854 echo "export PATH_KBUILD_BIN" >> $ENV
1855 echo "path_dev_bin=\"\$PATH_DEVTOOLS/\$BUILD_TARGET.\$BUILD_PLATFORM_ARCH\"/bin" >> $ENV
1856 echo "echo \"\$PATH\" | grep -q \"\$path_kbuild_bin\" || PATH=\"\$path_kbuild_bin:\$PATH\"" >> $ENV
1857 echo "echo \"\$PATH\" | grep -q \"\$path_dev_bin\" || PATH=\"\$path_dev_bin:\$PATH\"" >> $ENV
1858 echo "export PATH" >> $ENV
1859 echo "unset path_kbuild_bin path_dev_bin" >> $ENV
1860 KBUILD_SED="$KBUILDDIR_BIN/kmk_sed"
1861 elif check_avail "kmk" KBUILDDIR really; then
1862 # check for installed kBuild
1863 KBUILD_SED="`which_wrapper kmk_sed`"
1864 else
1865 fail
1866 fi
1867 log_success "found"
1868}
1869
1870
1871#
1872# Check for compiler.h
1873# Some Linux distributions include "compiler.h" in their libc linux
1874# headers package, some don't. Most don't need it, building might (!)
1875# not succeed on openSUSE without it.
1876#
1877# See http://www.mail-archive.com/qemu-devel%40nongnu.org/msg07980.html
1878#
1879check_compiler_h()
1880{
1881 test_header compiler.h
1882 if test ! -f "/usr/include/linux/compiler.h"; then
1883 log_success "compiler.h not found"
1884 else
1885 cnf_append "VBOX_WITH_LINUX_COMPILER_H" "1"
1886 log_success "compiler.h found"
1887 fi
1888}
1889
1890#
1891# Check for libcap.
1892# Required to pass CAP_NET_RAW to our binaries to allow to open SOCK_RAW
1893# sockets for doing ICMP requests.
1894#
1895check_libcap()
1896{
1897 test_header "libcap library"
1898 cat > $ODIR.tmp_src.cc << EOF
1899#include <cstdio>
1900#include <sys/types.h>
1901#include <linux/types.h>
1902#include <sys/capability.h>
1903
1904extern "C" int main(void)
1905{
1906 char buf[1024];
1907 cap_t caps = cap_get_proc();
1908 snprintf(buf, sizeof(buf), "Current caps are '%s'\n", cap_to_text(caps, NULL));
1909 return 0;
1910}
1911EOF
1912 if test_compile $LIBCAP libcap libcap; then
1913 if test_execute; then
1914 log_success "found"
1915 fi
1916 fi
1917}
1918
1919#
1920# Check if we are able to build 32-bit applications (needed for the guest additions)
1921#
1922check_32bit()
1923{
1924 test_header "32-bit support"
1925 cat > $ODIR.tmp_src.c << EOF
1926#include <stdint.h>
1927int main(void)
1928{
1929 return 0;
1930}
1931EOF
1932 echo "compiling the following source file:" >> $LOG
1933 cat $ODIR.tmp_src.c >> $LOG
1934 echo "using the following command line:" >> $LOG
1935 echo "$CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c" >> $LOG
1936 $CC -m32 -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.c >> $LOG 2>&1
1937 if [ $? -ne 0 ]; then
1938 echo
1939 echo " Cannot compile 32-bit applications (missing headers and/or libraries)!"
1940 echo " Check the file $LOG for detailed error information."
1941 fail
1942 else
1943 echo "executing the binary" >> $LOG
1944 $ODIR.tmp_out 2> $ODIR.test_execute.log
1945 rc=$?
1946 cat $ODIR.test_execute.log >> $LOG
1947 if [ $rc -ne 0 ]; then
1948 echo
1949 echo " Cannot execute 32-bit applications! Either enable 32-bit support in the"
1950 echo " kernel configuration or use --disable-vmmraw to disable 32-bit guests."
1951 fail
1952 return 1
1953 fi
1954 fi
1955 log_success ""
1956}
1957
1958
1959#
1960# Check for Python
1961#
1962check_python()
1963{
1964 test_header "Python support"
1965
1966 # On darwin this is a on/off decision only
1967 if [ "$OS" = "darwin" ]; then
1968 echo "enabled"
1969 cnf_append "VBOX_WITH_PYTHON" "1"
1970 return
1971 fi
1972
1973 cat > $ODIR.tmp_src.cc << EOF
1974#include <cstdio>
1975#include <Python.h>
1976extern "C" int main(void)
1977{
1978 Py_Initialize();
1979 printf("found version %s", PY_VERSION);
1980#if PY_VERSION_HEX >= 0x02060000
1981 printf(", OK.\n");
1982 return 0;
1983#else
1984 printf(", expected version 2.6 or higher\n");
1985 return 1;
1986#endif
1987}
1988EOF
1989 found=
1990 SUPPYTHONLIBS="python2.7 python2.6 python3.1 python3.2 python3.3 python3.4 python3.4m python3.5 python3.5m python3.6 python3.6m"
1991 for p in $PYTHONDIR; do
1992 for d in $SUPPYTHONLIBS; do
1993 for b in lib/x86_64-linux-gnu lib/i386-linux-gnu lib64 lib/64 lib; do
1994 echo "compiling the following source file:" >> $LOG
1995 cat $ODIR.tmp_src.cc >> $LOG
1996 echo "using the following command line:" >> $LOG
1997 echo "$CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so" >> $LOG
1998 $CXX -O -Wall -o $ODIR.tmp_out $ODIR.tmp_src.cc -I$p/include/$d $p/$b/lib$d.so >> $LOG 2>&1
1999 if [ $? -eq 0 ]; then
2000 found=1
2001 break
2002 fi
2003 done
2004 if [ -n "$found" ]; then break; fi
2005 done
2006 if [ -n "$found" ]; then break; fi
2007 done
2008 if [ -n "$found" ]; then
2009 if test_execute; then
2010 cnf_append "VBOX_WITH_PYTHON" "1"
2011 cnf_append "VBOX_PATH_PYTHON_INC" "$p/include/$d"
2012 cnf_append "VBOX_LIB_PYTHON" "$p/$b/lib$d.so"
2013 else
2014 log_failure "Python not working"
2015 fail
2016 fi
2017 else
2018 log_failure "Python not found"
2019 fail
2020 fi
2021}
2022
2023
2024#
2025# Check for Java
2026#
2027check_java()
2028{
2029 test_header "Java support"
2030 log_success
2031}
2032
2033
2034#
2035# Setup wine
2036#
2037setup_wine()
2038{
2039 test_header "Wine support"
2040 if ! which_wrapper wine > /dev/null; then
2041 echo " wine binary not found"
2042 fail
2043 fi
2044 if ! which_wrapper wine > /dev/null; then
2045 echo " wine not found"
2046 fail
2047 fi
2048 wine_version="`wine --version`"
2049 case "`expr "$wine_version" : 'wine-\([0-9.]*\)' '>' 1.1.43`" in
2050 "0")
2051 if ! which_wrapper wineprefixcreate > /dev/null; then
2052 echo " wineprefixcreate not found"
2053 fail
2054 fi
2055 ;;
2056 *) eval "wineprefixcreate() { true ; }" ;; # now created automatically
2057 esac
2058 export WINEPREFIX="${ODIR}wine.$BUILD_MACHINE"
2059 echo "WINEPREFIX=\"${ODIR}wine.$BUILD_MACHINE\"" >> $ENV
2060 echo "export WINEPREFIX" >> $ENV
2061 rm -rf $WINEPREFIX
2062 mkdir -p $WINEPREFIX
2063 touch $WINEPREFIX/.no_prelaunch_window_flag
2064 if ! wineprefixcreate -q > /dev/null 2>&1; then
2065 echo " wineprefixcreate failed"
2066 fail
2067 fi
2068 tmp=.tmp.wine.reg
2069 rm -f $tmp
2070 echo 'REGEDIT4' > $tmp
2071 echo '' >> $tmp
2072 echo '[HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Session Manager\Environment]' >> $tmp
2073 echo "\"PATH\"=\"c:\\\\\\\\windows\\\\\\\\system32;c:\\\\\\\\windows;z:$DEVDIR/win.x86/vcc/v8/bin/Microsoft.VC80.CRT;z:$DEVDIR/win.x86/HTML_Help_Workshop/v1.3\"" >> $tmp
2074 echo '' >> $tmp
2075 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhc.exe\DllOverrides]' >> $tmp
2076 echo '"itss"="native"' >> $tmp
2077 echo '' >> $tmp
2078 echo '[HKEY_CURRENT_USER\Software\Wine\AppDefaults\hhw.exe\DllOverrides]' >> $tmp
2079 echo '"itss"="native"' >> $tmp
2080 echo '' >> $tmp
2081 if ! wine regedit $tmp > /dev/null 2>&1; then
2082 rm -f $tmp
2083 echo " failed to load registry changes (path)."
2084 fail
2085 fi
2086 rm -f $tmp
2087 log_success "found"
2088}
2089
2090
2091#
2092# Check for gSOAP.
2093#
2094check_gsoap()
2095{
2096 test_header "GSOAP compiler"
2097 if [ -z "$GSOAP" -a -z "$GSOAP_IMPORT" ]; then
2098 if which_wrapper pkg-config > /dev/null; then
2099 GSOAP_CXX_LIBS=`pkg-config gsoapssl++ --libs 2>> $LOG`
2100 if [ $? -eq 0 ]; then
2101 GSOAP=`pkg-config gsoapssl++ --variable=exec_prefix`
2102 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2103 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2104 GSOAP_IMPORT="$GSOAP/include/gsoap"
2105 fi
2106 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2107 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2108 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2109 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2110 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2111 else
2112 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2113 fi
2114 cnf_append "VBOX_GSOAP_CXX_LIBS" "`strip_l "$GSOAP_CXX_LIBS"`"
2115 gsoap_version=`pkg-config gsoapssl++ --modversion`
2116 log_success "found version $gsoap_version"
2117 return
2118 fi
2119 fi
2120 fi
2121 if [ -z "$GSOAP" ]; then
2122 GSOAP="/usr"
2123 fi
2124 if which_wrapper "$GSOAP/bin/soapcpp2" > /dev/null; then
2125 if which_wrapper "$GSOAP/bin/wsdl2h" > /dev/null; then
2126 if [ -f "$GSOAP/include/stdsoap2.h" ]; then
2127 # TODO: Check for libgsoap++.a/so
2128
2129 if [ -z "$GSOAP_IMPORT" ]; then
2130 GSOAP_IMPORT="$GSOAP/share/gsoap/import"
2131 if [ ! -d "$GSOAP_IMPORT" -a -d "$GSOAP/include/gsoap" ]; then
2132 GSOAP_IMPORT="$GSOAP/include/gsoap"
2133 fi
2134 fi
2135 if [ -f "$GSOAP_IMPORT/stlvector.h" ]; then
2136 cnf_append "VBOX_GSOAP_INSTALLED" "1"
2137 cnf_append "VBOX_PATH_GSOAP" "$GSOAP"
2138 cnf_append "VBOX_PATH_GSOAP_IMPORT" "$GSOAP_IMPORT"
2139 if [ -f "$GSOAP/share/gsoap/stdsoap2.cpp" ]; then
2140 cnf_append "VBOX_GSOAP_CXX_SOURCES" "$GSOAP/share/gsoap/stdsoap2.cpp"
2141 else
2142 cnf_append "VBOX_GSOAP_CXX_SOURCES" ""
2143 fi
2144 cnf_append "VBOX_GSOAP_CXX_LIBS" "libgsoapssl++"
2145 log_success "found"
2146 else
2147 log_failure "stlvector.h not found -- disabling webservice"
2148 cnf_append "VBOX_WITH_WEBSERVICES" ""
2149 fi
2150 else
2151 log_failure "stdsoap2.h not found -- disabling webservice"
2152 cnf_append "VBOX_WITH_WEBSERVICES" ""
2153 fi
2154 else
2155 log_failure "wsdl2h not found -- disabling webservice"
2156 cnf_append "VBOX_WITH_WEBSERVICES" ""
2157 fi
2158 else
2159 log_failure "soapcpp2 not found -- disabling webservice"
2160 cnf_append "VBOX_WITH_WEBSERVICES" ""
2161 fi
2162}
2163
2164
2165#
2166# Check Xcode path
2167#
2168check_xcode_sdk_path()
2169{
2170 # Check if WITH_XCODE_DIR is set.
2171 if [ -z "$WITH_XCODE_DIR" ]; then
2172 echo "Please specify --with-xcode-dir option."
2173 return 0
2174 fi
2175
2176 # Check if specified path exists and is a directory.
2177 if [ -d "$1" ]; then
2178 return 1
2179 else
2180 echo "Xcode path [$1] not found."
2181 return 0
2182 fi
2183}
2184
2185#
2186# Determines the Darwin version.
2187# @todo This should really check the Xcode/SDK version.
2188#
2189check_darwinversion()
2190{
2191 test_header "Darwin version"
2192 darwin_ver=`uname -r`
2193 case "$darwin_ver" in
2194 17\.*)
2195 check_xcode_sdk_path "$WITH_XCODE_DIR"
2196 [ $? -eq 1 ] || fail
2197 darwin_ver="10.13" # High Sierra
2198 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2199 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2200 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2201 ;;
2202 16\.*)
2203 check_xcode_sdk_path "$WITH_XCODE_DIR"
2204 [ $? -eq 1 ] || fail
2205 darwin_ver="10.12" # Sierra
2206 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2207 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2208 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2209 ;;
2210 15\.*)
2211 check_xcode_sdk_path "$WITH_XCODE_DIR"
2212 [ $? -eq 1 ] || fail
2213 darwin_ver="10.11" # El Capitan
2214 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2215 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2216 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2217 ;;
2218 14\.*)
2219 check_xcode_sdk_path "$WITH_XCODE_DIR"
2220 [ $? -eq 1 ] || fail
2221 darwin_ver="10.10" # Yosemite
2222 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2223 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2224 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2225 ;;
2226 13\.*)
2227 check_xcode_sdk_path "$WITH_XCODE_DIR"
2228 [ $? -eq 1 ] || fail
2229 darwin_ver="10.9" # Mavericks
2230 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2231 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2232 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2233 ;;
2234 12\.*)
2235 darwin_ver="10.8" # Mountain Lion
2236 if [ ! -z "$WITH_XCODE_DIR" ]; then
2237 sdk=$WITH_XCODE_DIR/Developer/SDKs/MacOSX10.6.sdk
2238 cnf_append "VBOX_WITH_MACOSX_COMPILERS_FROM_DEVEL" "1"
2239 cnf_append "VBOX_PATH_MACOSX_DEVEL_ROOT" "$WITH_XCODE_DIR/Developer"
2240 else
2241 sdk=/Developer/SDKs/MacOSX10.6.sdk
2242 fi
2243 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2244 ;;
2245 11\.*)
2246 darwin_ver="10.7" # Lion
2247 sdk=/Developer/SDKs/MacOSX10.6.sdk
2248 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2249 ;;
2250 10\.*)
2251 darwin_ver="10.6" # Snow Leopard
2252 if [ "$BUILD_MACHINE" = "x86" ]; then
2253 sdk=/Developer/SDKs/MacOSX10.5.sdk
2254 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2255 cnf_append "VBOX_MACOS_10_5_WORKAROUND" "1"
2256 else
2257 sdk=/Developer/SDKs/MacOSX10.6.sdk
2258 CXX_FLAGS="-mmacosx-version-min=10.6 -isysroot $sdk -Wl,-syslibroot,$sdk"
2259 fi
2260# test "$CC" = "gcc" && CC="gcc-4.0"
2261# test "$CXX" = "g++" && CXX="g++-4.0"
2262 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2263 ;;
2264 9\.*)
2265 darwin_ver="10.5" # Leopard
2266 sdk=/Developer/SDKs/MacOSX10.5.sdk
2267 CXX_FLAGS="-mmacosx-version-min=10.5 -isysroot $sdk -Wl,-syslibroot,$sdk"
2268# test "$CC" = "gcc" && CC="gcc-4.0"
2269# test "$CXX" = "g++" && CXX="g++-4.0"
2270 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2271 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2272 ;;
2273 8\.*)
2274 darwin_ver="10.4" # Tiger
2275 sdk=/Developer/SDKs/MacOSX10.4u.sdk
2276 CXX_FLAGS="-mmacosx-version-min=10.4 -isysroot $sdk -Wl,-syslibroot,$sdk"
2277# test "$CC" = "gcc" && CC="gcc-4.0"
2278# test "$CXX" = "g++" && CXX="g++-4.0"
2279 cnf_append "VBOX_WITH_COCOA_QT" ""
2280 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_6" "1"
2281 cnf_append "VBOX_WITHOUT_VBOXPYTHON_FOR_OSX_10_7" "1"
2282 ;;
2283 *)
2284 echo " failed to determine Darwin version. (uname -r: $darwin_ver)"
2285 fail
2286 darwin_ver="unknown"
2287 ;;
2288 esac
2289 log_success "found version $darwin_ver (SDK: $sdk)"
2290}
2291
2292
2293check_makeself()
2294{
2295 test_header "makeself"
2296 if check_avail "$MAKESELF" makeself; then
2297 makeself_ver=`$MAKESELF --version|grep version|sed 's+^Makeself.*version \([0-9\.]*\).*+\1+'`
2298 if [ $? -ne 0 ]; then
2299 log_failure "makeself not working"
2300 fail
2301 else
2302 log_success "found version $makeself_ver"
2303 cnf_append "VBOX_MAKESELF" "`which_wrapper $MAKESELF`"
2304 fi
2305 fi
2306}
2307
2308
2309#
2310# Show help
2311#
2312show_help()
2313{
2314cat << EOF
2315Usage: ./configure [OPTIONS]...
2316
2317Configuration:
2318 -h, --help display this help and exit
2319 --nofatal don't abort on errors
2320EOF
2321[ $WITH_XPCOM -eq 1 ] && echo " --disable-xpcom disable XPCOM and related stuff"
2322[ $WITH_PYTHON -eq 1 ] && echo " --disable-python disable python bindings"
2323[ $WITH_JAVA -eq 1 ] && echo " --disable-java disable java bindings"
2324[ $WITH_VMMRAW -eq 1 ] && echo " --disable-vmmraw disable VMM raw mode (VT-x/AMD-V mandatory!)"
2325[ $WITH_SDL_TTF -eq 1 ] && echo " --disable-sdl-ttf disable SDL_ttf detection"
2326[ $WITH_QT5 -eq 1 ] && echo " --disable-qt disable Qt detection"
2327[ $WITH_ALSA -eq 1 ] && echo " --disable-alsa disable the ALSA sound backend"
2328[ $WITH_PULSE -eq 1 ] && echo " --disable-pulse disable the PulseAudio backend"
2329[ $WITH_DBUS -eq 1 ] && echo " --disable-dbus don't use DBus and hal for hardware detection"
2330[ $WITH_KMODS -eq 1 ] && echo " --disable-kmods don't build Linux kernel modules (host and guest)"
2331[ $WITH_OPENGL -eq 1 ] && echo " --disable-opengl disable OpenGL support (2D & 3D)"
2332[ $WITH_QT5 -eq 0 ] && echo " --enable-qt5 enable Qt5 detection"
2333[ $WITH_GSOAP -eq 0 ] && echo " --enable-webservice enable the webservice stuff"
2334[ $OSE -eq 1 ] && echo " --enable-vnc enable the VNC server"
2335[ $OSE -eq 0 ] && echo " --disable-extpack don't build the extpack"
2336[ $WITH_DOCS -eq 1 ] && echo " --disable-docs don't build the documentation"
2337[ $WITH_LIBVPX -eq 1 ] && echo " --disable-libvpx don't use libvpx for video capturing"
2338[ $WITH_LIBOPUS -eq 1 ] && echo " --disable-libopus don't use libopus for audio capturing"
2339[ "$OS" = "linux" -o "$OS" = "freebsd" ] && echo " --enable-vde enable VDE networking"
2340cat << EOF
2341 --disable-udptunnel disable UDP tunnel networking
2342 --disable-devmapper disable device mapper library access
2343 --disable-hardening don't be strict about /dev/vboxdrv access
2344 --build-libxml2 build libxml2 from sources
2345EOF
2346[ $OSE -eq 0 ] && cat << EOF
2347 --build-libssl build openssl from sources
2348 --build-libcurl build libcurl from sources
2349 --build-libvpx build libvpx from sources
2350EOF
2351[ "$OS" != "darwin" ] && echo " --setup-wine setup a Wine directory and register the hhc hack"
2352cat << EOF
2353 --only-additions only build the Guest Additions
2354
2355Paths:
2356 --with-gcc=PATH location of the gcc compiler [$CC]
2357 --with-g++=PATH location of the g++ compiler [$CXX]
2358 --with-kbuild=DIR kbuild directory [$KBUILDDIR]
2359 --with-iasl=PATH location of the iasl compiler [$IASL]
2360 --with-makeself=PATH location of makeself [$MAKESELF]
2361EOF
2362[ "$OS" = "darwin" ] && echo " --with-xcode-dir=DIR custom path to Xcode root directory; it is assumed that Xcode"
2363[ "$OS" = "darwin" ] && echo " contains OS X 10.6 SDK (required for Mountain Lion and newer hosts"
2364[ "$OS" = "darwin" ] && echo " only, ignored for the rest)"
2365[ "$OS" = "linux" ] && echo " --with-linux=DIR Linux kernel source directory [$LINUX]"
2366[ $WITH_QT5 -eq 1 ] && echo " --with-qt-dir=DIR directory for Qt headers/libraries [pkgconfig]"
2367[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-dir=PATH directory for gSOAP compiler/headers/libraries"
2368[ $WITH_GSOAP -eq 1 ] && echo " (soapcpp2 and wsdl2h, soapstd2.h, libgsoap++.a/so)"
2369[ $WITH_GSOAP -eq 1 ] && echo " --with-gsoap-import=PATH directory for gSOAP import files (stlvector.h)"
2370cat << EOF
2371 --with-openssl-dir=DIR directory for OpenSSL headers/libraries
2372 --with-ow-dir=DIR directory where Open Watcom can be found [$WATCOM]
2373 --out-path=PATH the folder to which configuration and build output
2374 should go
2375
2376Build type:
2377 -d, --build-debug build with debugging symbols and assertions
2378 --build-profile build with profiling support
2379 --build-headless build headless (without any GUI frontend)
2380EOF
2381 exit 0
2382}
2383
2384
2385#
2386# The body.
2387#
2388
2389# test if we are OSE
2390if [ $OSE -eq 1 -a -r "`cd \`dirname $0\`; pwd`/src/VBox/RDP/server/server.cpp" ]; then
2391 OSE=0
2392 # Set this as a reminder to print a log message once we know the path of the
2393 # log file
2394 NOT_OSE=1
2395fi
2396
2397# Change OS specific defaults; must be before all other stuff
2398if [ "$OS" = "darwin" ]; then
2399 WITH_SDL=0
2400 WITH_SDL_TTF=0
2401 WITH_X11=0
2402 WITH_ALSA=0
2403 WITH_PULSE=0
2404 WITH_DBUS=0
2405 WITH_KMODS=0
2406 BUILD_LIBXML2=1
2407 BUILD_LIBVPX=1
2408 [ $OSE -eq 1 ] || BUILD_LIBCURL=1
2409 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2410 [ $OSE -eq 1 ] && WITH_LIBOPUS=0
2411 WITH_XCODE_DIR=""
2412elif [ "$OS" = "haiku" ]; then
2413 #WITH_SDL=0
2414 WITH_SDL_TTF=0
2415 WITH_X11=0
2416 WITH_ALSA=0
2417 WITH_PULSE=0
2418 WITH_DBUS=0
2419 WITH_KMODS=0
2420 WITH_LIBIDL=0
2421 WITH_XPCOM=0
2422 BUILD_LIBXSLT=1
2423 BUILD_LIBXML2=1
2424 WITH_LIBVPX=0
2425 WITH_LIBOPUS=0
2426 # it is part of libroot, which is linked by default,
2427 # but the script wants something
2428 LIBPTHREAD="-lroot"
2429 #[ $OSE -eq 1 ] || BUILD_LIBCURL=1
2430 [ $OSE -eq 1 ] || BUILD_LIBSSL=1
2431elif [ "$OS" = "solaris" ]; then
2432 [ $OSE -eq 1 ] && WITH_LIBVPX=0
2433 [ $OSE -eq 1 ] && WITH_LIBOPUS=0
2434fi
2435
2436# scan command line options
2437for option in "$@"; do
2438 case "$option" in
2439 --help|-help|-h)
2440 show_help
2441 ;;
2442 --nofatal)
2443 nofatal=1
2444 ;;
2445 --env-only)
2446 ENV_ONLY=1
2447 ;;
2448 --with-gcc=*)
2449 CC=`echo $option | cut -d'=' -f2`
2450 ;;
2451 --with-g++=*)
2452 CXX=`echo $option | cut -d'=' -f2`
2453 ;;
2454 --with-kbuild=*)
2455 KBUILDDIR=`echo $option | cut -d'=' -f2`
2456 if echo $KBUILDDIR|grep -q "$INVALID_CHARS"; then
2457 echo "Error: KBUILDDIR contains invalid characters!"
2458 exit 1
2459 fi
2460 ;;
2461 --with-qt-dir=*)
2462 [ $WITH_QT5 -eq 1 ] && QT5DIR=`echo $option | cut -d'=' -f2`
2463 [ $WITH_QT5 -eq 1 ] && QT5DIR_PKGCONFIG=0
2464 ;;
2465 --with-qt5-minor=*)
2466 QT5MIN=`echo $option | cut -d'=' -f2`
2467 ;;
2468 --with-qt5-major=*)
2469 QT5MAJ=`echo $option | cut -d'=' -f2`
2470 ;;
2471 --with-openssl-dir=*)
2472 OPENSSLDIR=`echo $option | cut -d'=' -f2`
2473 INCCRYPTO="-I${OPENSSLDIR}/include"
2474 LIBCRYPTO="${OPENSSLDIR}/lib/libcrypto.a ${OPENSSLDIR}/lib/libssl.a"
2475 ;;
2476 --with-ow-dir=*)
2477 WATCOM=`echo $option | cut -d'=' -f2`
2478 ;;
2479 --with-gsoap-dir=*)
2480 GSOAP=`echo $option | cut -d'=' -f2`
2481 ;;
2482 --with-gsoap-import=*)
2483 GSOAP_IMPORT=`echo $option | cut -d'=' -f2`
2484 ;;
2485 --with-iasl=*)
2486 IASL=`echo $option | cut -d'=' -f2`
2487 ;;
2488 --with-xcode-dir=*)
2489 WITH_XCODE_DIR=`echo $option | cut -d'=' -f2`
2490 echo $option
2491 ;;
2492 --with-linux=*)
2493 LINUX=`echo $option | cut -d'=' -f2`
2494 ;;
2495 --with-makeself=*)
2496 MAKESELF=`echo $option | cut -d'=' -f2`
2497 ;;
2498 --target-arch=*)
2499 TARGET_MACHINE=`echo $option | cut -d'=' -f2`
2500 ;;
2501 --disable-xpcom)
2502 [ $WITH_XPCOM -eq 1 ] && WITH_XPCOM=0
2503 ;;
2504 --disable-python)
2505 [ $WITH_PYTHON -eq 1 ] && WITH_PYTHON=0
2506 ;;
2507 --disable-java)
2508 [ $WITH_JAVA -eq 1 ] && WITH_JAVA=0
2509 ;;
2510 --disable-vmmraw)
2511 [ $WITH_VMMRAW -eq 1 ] && WITH_VMMRAW=0
2512 ;;
2513 --disable-sdl-ttf)
2514 [ $WITH_SDL_TTF -eq 1 ] && WITH_SDL_TTF=0
2515 ;;
2516 --disable-qt)
2517 [ $WITH_QT5 -eq 1 ] && WITH_QT5=0
2518 ;;
2519 --enable-qt5)
2520 [ $WITH_QT5 -eq 0 ] && WITH_QT5=1
2521 ;;
2522 --passive-mesa)
2523 PASSIVE_MESA=1
2524 ;;
2525 --disable-alsa)
2526 [ $WITH_ALSA -eq 1 ] && WITH_ALSA=0
2527 ;;
2528 --disable-pulse)
2529 [ $WITH_PULSE -eq 1 ] && WITH_PULSE=0
2530 ;;
2531 --enable-pulse)
2532 WITH_PULSE=2
2533 ;;
2534 --disable-dbus)
2535 [ $WITH_DBUS -eq 1 ] && WITH_DBUS=0
2536 ;;
2537 --disable-kmods)
2538 [ $WITH_KMODS -eq 1 ] && WITH_KMODS=0
2539 ;;
2540 --disable-opengl)
2541 [ $WITH_OPENGL -eq 1 ] && WITH_OPENGL=0
2542 ;;
2543 --enable-webservice)
2544 [ $WITH_GSOAP -eq 0 ] && WITH_GSOAP=1
2545 ;;
2546 --enable-vnc)
2547 WITH_VNC=1
2548 ;;
2549 --disable-hardening)
2550 WITH_HARDENING=0
2551 ;;
2552 --disable-extpack)
2553 WITH_EXTPACK=0
2554 ;;
2555 --disable-docs)
2556 WITH_DOCS=0
2557 ;;
2558 --enable-hardening)
2559 WITH_HARDENING=2
2560 ;;
2561 --build-libopus)
2562 BUILD_LIBOPUS=1
2563 ;;
2564 --disable-udptunnel)
2565 WITH_UDPTUNNEL=0
2566 ;;
2567 --enable-vde)
2568 WITH_VDE=1
2569 ;;
2570 --disable-devmapper)
2571 WITH_DEVMAPPER=0
2572 ;;
2573 --disable-libvpx)
2574 WITH_LIBVPX=0
2575 ;;
2576 --disable-libopus)
2577 WITH_LIBOPUS=0
2578 ;;
2579 --disable-sdl)
2580 WITH_SDL=0
2581 ;;
2582 --build-debug|-d)
2583 BUILD_TYPE=debug
2584 ;;
2585 --build-profile)
2586 BUILD_TYPE=profile
2587 ;;
2588 --build-libxml2)
2589 BUILD_LIBXML2=1
2590 ;;
2591 --build-libssl)
2592 BUILD_LIBSSL=1
2593 ;;
2594 --build-libcurl)
2595 BUILD_LIBCURL=1
2596 ;;
2597 --build-libvpx)
2598 BUILD_LIBVPX=1
2599 ;;
2600 --build-headless)
2601 HEADLESS=1
2602 WITH_SDL=0
2603 WITH_SDL_TTF=0
2604 WITH_X11=0
2605 WITH_OPENGL=0
2606 WITH_QT5=0
2607 ;;
2608 --ose)
2609 OSE=2
2610 ;;
2611 --odir=*)
2612 ODIR="`echo $option | cut -d'=' -f2`/"
2613 ODIR_OVERRIDE=1
2614 ;;
2615 --out-path=*)
2616 out_path="`echo $option | cut -d'=' -f2`/"
2617 if [ -d $out_path ]; then
2618 saved_path="`pwd`"
2619 cd $out_path
2620 OUT_PATH="`pwd`"
2621 cd $saved_path
2622 OUT_PATH_OVERRIDE=1
2623 if [ $ODIR_OVERRIDE -eq 0 ]; then
2624 # This variable has not *yet* been overridden. That can still happen.
2625 ODIR=$OUT_PATH/
2626 fi
2627 else
2628 echo "Error: invalid folder \"$out_path\" in option \"$option\""
2629 exit 1
2630 fi
2631 ;;
2632 --setup-wine)
2633 [ "$OS" != "darwin" ] && SETUP_WINE=1
2634 ;;
2635 --only-additions)
2636 ONLY_ADDITIONS=1
2637 ;;
2638 *)
2639 echo
2640 echo "Unrecognized option \"$option\""
2641 echo
2642 show_help
2643 ;;
2644 esac
2645done
2646
2647LOG="$ODIR$LOG"
2648ENV="$ODIR$ENV"
2649CNF="$ODIR$CNF"
2650
2651# initialize output files
2652cat > $LOG << EOF
2653# Log file generated by
2654#
2655# '$0 $*'
2656#
2657
2658EOF
2659cat > $CNF << EOF
2660# -*- Makefile -*-
2661#
2662# automatically generated by
2663#
2664# '$0 $*'
2665#
2666# It will be completely overwritten if configure is executed again.
2667#
2668
2669EOF
2670cat > $ENV << EOF
2671#!/bin/bash
2672#
2673# automatically generated by
2674#
2675# '$0 $*'
2676#
2677# It will be completely overwritten if configure is executed again.
2678# Make sure you source this file once before you start to build VBox.
2679#
2680
2681EOF
2682
2683# Print log warning about OSE if necessary
2684if [ -n "$NOT_OSE" ]; then
2685 echo "Found RDP server, assuming VBOX_OSE = FALSE" >> $LOG
2686 echo >> $LOG
2687fi
2688
2689
2690if [ "$BUILD_TYPE" = "debug" ]; then
2691 echo "Creating DEBUG build!" >> $LOG
2692elif [ "$BUILD_TYPE" = "profile" ]; then
2693 echo "Creating PROFILE build!" >> $LOG
2694fi
2695
2696# first determine our environment
2697check_environment
2698check_kbuild
2699
2700[ -n "$ENV_ONLY" ] && exit 0
2701
2702# append the tools directory to the default search path
2703echo "$PATH" | grep -q "$DEVDIR_BIN" || PATH="$PATH:$DEVDIR_BIN"
2704export PATH
2705
2706# if we will be writing to a different out directory then set this up now
2707if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2708 echo "AUTOCFG=$OUT_PATH/AutoConfig.kmk" >> $ENV
2709 echo "export AUTOCFG" >> $ENV
2710 echo "LOCALCFG=$OUT_PATH/LocalConfig.kmk" >> $ENV
2711 echo "export LOCALCFG" >> $ENV
2712 echo "PATH_OUT_BASE=$OUT_PATH" >> $ENV
2713 echo "export PATH_OUT_BASE" >> $ENV
2714fi
2715
2716# don't bother people with -Werror
2717cnf_append "VBOX_GCC_WERR" "\$(NO_SUCH_VARIABLE)"
2718
2719# some things are not available in for OSE
2720if [ $OSE -ge 1 ]; then
2721 cnf_append "VBOX_OSE" "1"
2722 cnf_append "VBOX_WITH_VALIDATIONKIT" ""
2723 cnf_append "VBOX_WITH_WIN32_ADDITIONS" ""
2724
2725 if [ "$OS" = "linux" ]; then
2726 cnf_append "VBOX_WITH_LINUX_ADDITIONS" "1"
2727 else
2728 cnf_append "VBOX_WITH_LINUX_ADDITIONS" ""
2729 fi
2730 echo >> $CNF
2731fi
2732
2733# extpack
2734if [ $ONLY_ADDITIONS -eq 1 ]; then
2735 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2736elif [ $OSE -eq 0 ]; then
2737 if [ $WITH_EXTPACK -eq 1 ]; then
2738 BUILD_LIBSSL=1
2739 else
2740 cnf_append "VBOX_WITH_EXTPACK_PUEL_BUILD" ""
2741 fi
2742fi
2743
2744# headless
2745if [ -n "$HEADLESS" ]; then
2746 cnf_append "VBOX_HEADLESS" "1"
2747fi
2748
2749# emit disable directives corresponding to any --disable-xxx options.
2750if [ $WITH_OPENGL -eq 0 ]; then
2751 cnf_append "VBOX_WITH_CROGL" ""
2752 cnf_append "VBOX_WITH_VIDEOHWACCEL" ""
2753 cnf_append "VBOX_GUI_USE_QGL" ""
2754fi
2755[ $WITH_XPCOM -eq 0 ] && cnf_append "VBOX_WITH_MAIN" ""
2756[ $WITH_QT5 -eq 0 ] && cnf_append "VBOX_WITH_QTGUI" ""
2757[ $WITH_SDL_TTF -eq 0 ] && cnf_append "VBOX_WITH_SECURELABEL" ""
2758[ $WITH_PYTHON -eq 0 ] && cnf_append "VBOX_WITH_PYTHON" ""
2759[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JXPCOM" ""
2760[ $WITH_JAVA -eq 0 ] && cnf_append "VBOX_WITH_JWS" ""
2761[ $WITH_HARDENING -eq 0 ] && cnf_append "VBOX_WITHOUT_HARDENING" "1"
2762[ $WITH_HARDENING -eq 2 ] && cnf_append "VBOX_WITH_HARDENING" "2"
2763[ $WITH_VMMRAW -eq 0 ] && cnf_append "VBOX_WITH_RAW_MODE" ""
2764if [ $WITH_LIBVPX -eq 0 ]; then
2765 cnf_append "VBOX_WITH_LIBVPX" ""
2766 cnf_append "VBOX_WITH_RECORDING" ""
2767fi
2768if [ $WITH_LIBOPUS -eq 0 ]; then
2769 cnf_append "VBOX_WITH_LIBOPUS" ""
2770 cnf_append "VBOX_WITH_AUDIO_RECORDING" ""
2771fi
2772
2773# Darwin-specific
2774if [ "$OS" = "darwin" ]; then
2775 check_darwinversion
2776fi
2777# the tools
2778check_gcc
2779if [ $ONLY_ADDITIONS -eq 0 ]; then
2780 check_open_watcom
2781 [ "$OS" != "darwin" ] && check_iasl
2782 # don't check for yasm for the time beeing as 0.40 and 0.50 both have known bugs
2783 # [ "$OS" != "darwin" ] && check_yasm
2784 [ "$OS" != "darwin" ] && check_xsltproc
2785fi
2786
2787# the libraries
2788if [ $ONLY_ADDITIONS -eq 0 ]; then
2789 [ "$OS" != "darwin" ] && check_pthread
2790 check_libxml2
2791 [ $WITH_LIBIDL -eq 1 ] && check_libidl
2792 check_ssl
2793 check_curl
2794 [ $WITH_LIBVPX -eq 1 ] && check_vpx
2795 [ $WITH_LIBOPUS -eq 1 ] && check_libopus
2796 [ "$OS" != "darwin" ] && check_z
2797 [ "$OS" != "darwin" ] && check_png
2798 [ $OSE -eq 0 -a "$OS" = "linux" ] && check_pam
2799 if [ $WITH_SDL -eq 1 ]; then
2800 check_sdl
2801 else
2802 cnf_append "VBOX_WITH_VBOXSDL" ""
2803 fi
2804 [ $WITH_SDL_TTF -eq 1 -a $OSE -eq 0 ] && check_sdl_ttf
2805 [ $WITH_X11 -eq 1 ] && check_x
2806 # TODO check for xcomposite-dev (X11/extensions/Xcomposite.h, additions only)
2807 # TODO check for libxdamange-dev (X11/extensions/Xdamage.h, additions only)
2808 [ $WITH_X11 -eq 1 ] && check_xcursor
2809 [ $WITH_X11 -eq 1 ] && check_xinerama
2810 [ $WITH_X11 -eq 1 ] && check_xrandr
2811 [ $WITH_OPENGL -eq 1 ] && check_opengl
2812 [ $WITH_QT5 -eq 1 ] && check_qt5
2813 [ $WITH_PYTHON -eq 1 ] && check_python
2814 [ $WITH_JAVA -eq 1 ] && check_java
2815
2816 # PulseAudio
2817 if [ $WITH_PULSE -eq 1 ]; then
2818 check_pulse
2819 elif [ $WITH_PULSE -eq 0 ]; then # Force disabling PulseAudio.
2820 cnf_append "VBOX_WITH_AUDIO_PULSE" ""
2821 elif [ $WITH_PULSE -eq 2 ]; then # --enable-pulse was passed, force PulseAudio.
2822 cnf_append "VBOX_WITH_AUDIO_PULSE" "1"
2823 fi
2824fi
2825
2826# Linux-specific
2827if [ "$OS" = "linux" ]; then
2828 # don't check for the static libstdc++ in the PUEL version as we build the
2829 # additions at a dedicated box
2830 [ $OSE -ge 1 ] && check_staticlibstdcxx
2831 if [ $WITH_KMODS -eq 1 ]; then
2832 check_linux
2833 else
2834 cnf_append "VBOX_LINUX_SRC" ""
2835 cnf_append "VBOX_WITHOUT_LINUX_TEST_BUILDS" "1"
2836 fi
2837 if [ $ONLY_ADDITIONS -eq 0 ]; then
2838 if [ $WITH_ALSA -eq 1 ]; then
2839 check_alsa
2840 else
2841 cnf_append "VBOX_WITH_AUDIO_ALSA" ""
2842 fi
2843 if [ $WITH_DBUS -eq 0 ]; then
2844 cnf_append "VBOX_WITH_DBUS" ""
2845 fi
2846 if [ $WITH_DEVMAPPER -eq 1 ]; then
2847 check_libdevmapper
2848 else
2849 cnf_append "VBOX_WITH_DEVMAPPER" ""
2850 fi
2851 check_libcap
2852 fi
2853 check_compiler_h
2854 [ $ONLY_ADDITIONS -eq 0 -a "$BUILD_MACHINE" = "amd64" -a $WITH_VMMRAW -eq 1 ] && check_32bit
2855 # tools/common/makeself*
2856 [ $OSE -ge 1 ] && check_makeself
2857fi
2858
2859[ -n "$SETUP_WINE" ] && setup_wine
2860
2861if [ $ONLY_ADDITIONS -eq 0 -a $WITH_GSOAP -eq 1 ]; then
2862 check_gsoap
2863else
2864 if [ $OSE -ge 1 ]; then
2865 cnf_append "VBOX_WITH_WEBSERVICES" ""
2866 fi
2867fi
2868
2869# UDPTUNNEL
2870if [ $ONLY_ADDITIONS -eq 0 -a $WITH_UDPTUNNEL -eq 0 ]; then
2871 cnf_append "VBOX_WITH_UDPTUNNEL" ""
2872fi
2873
2874# VDE
2875if [ $ONLY_ADDITIONS -eq 0 -a "$OS" = "linux" -o "$OS" = "freebsd" ]; then
2876 if [ $WITH_VDE -eq 1 ]; then
2877 cnf_append "VBOX_WITH_VDE" "1"
2878 fi
2879fi
2880
2881# DOCS
2882if [ $ONLY_ADDITIONS -eq 1 -o $WITH_DOCS -eq 0 ]; then
2883 cnf_append "VBOX_WITH_DOCS" ""
2884 cnf_append "VBOX_WITH_DOCS_PACKING" ""
2885fi
2886
2887# VNC server support
2888if [ $ONLY_ADDITIONS -eq 0 -a $OSE -ge 1 ]; then
2889 if [ $WITH_VNC = 1 ]; then
2890 check_vncserver
2891 else
2892 cnf_append "VBOX_WITH_EXTPACK_VNC" ""
2893 fi
2894fi
2895
2896if [ $ONLY_ADDITIONS -eq 1 ]; then
2897 cnf_append "VBOX_ONLY_ADDITIONS" "1"
2898fi
2899
2900# success!
2901echo
2902echo "Successfully generated '$CNF' and '$ENV'."
2903echo "Source '$ENV' once before you start to build VBox:"
2904echo ""
2905echo " source $ENV"
2906echo " kmk"
2907echo ""
2908if [ "$OS" = "linux" ]; then
2909 if [ $OUT_PATH_OVERRIDE -eq 1 ]; then
2910 vbox_out_path=$OUT_PATH
2911 else
2912 vbox_out_path=./out
2913 fi
2914 echo "To compile the kernel modules, do:"
2915 echo ""
2916 echo " cd $vbox_out_path/$OS.$TARGET_MACHINE/$BUILD_TYPE/bin/src"
2917 echo " make"
2918 echo ""
2919fi
2920if [ $ONLY_ADDITIONS -eq 1 ]; then
2921 echo ""
2922 echo " Tree configured to build only the Guest Additions"
2923 echo ""
2924elif [ $WITH_HARDENING -gt 0 ]; then
2925 echo ""
2926 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2927 echo " Hardening is enabled which means that the VBox binaries will not run from"
2928 echo " the binary directory. The binaries have to be installed suid root and some"
2929 echo " more prerequisites have to be fulfilled which is normally done by installing"
2930 echo " the final package. For development, the hardening feature can be disabled"
2931 echo " by specifying the --disable-hardening parameter. Please never disable that"
2932 echo " feature for the final distribution!"
2933 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2934 echo ""
2935else
2936 echo ""
2937 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2938 echo " Hardening is disabled. Please do NOT build packages for distribution with"
2939 echo " disabled hardening!"
2940 echo " +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++ WARNING +++"
2941 echo ""
2942fi
2943echo "Enjoy!"
2944cleanup
Note: See TracBrowser for help on using the repository browser.

© 2023 Oracle
ContactPrivacy policyTerms of Use